! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 20:52 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module Tadpoles_munuSSM 
 
Use Model_Data_munuSSM 
Use SUSYMasses_munuSSM 
Use RGEs_munuSSM 
Use Control 

Use Mathematics 

Contains 


Subroutine SolveTadpoleEquations(g1,g2,g3,Yd,Ye,lam,Yv,Yu,kap,Td,Te,Tlam,             & 
& Tv,Tu,Tk,mq2,ml2,mHd2,mHu2,md2,mu2,me2,mv2,mlHd2,M1,M2,M3,vd,vu,vL,vR,Tad1Loop)

Implicit None
Real(dp),Intent(inout) :: g1,g2,g3,mHd2,mHu2,mv2,mlHd2(3),vd,vu,vL(3),vR

Complex(dp),Intent(inout) :: Yd(3,3),Ye(3,3),lam,Yv(3),Yu(3,3),kap,Td(3,3),Te(3,3),Tlam,Tv(3),Tu(3,3),             & 
& Tk,mq2(3,3),ml2(3,3),md2(3,3),mu2(3,3),me2(3,3),M1,M2,M3

Complex(dp), Intent(in) :: Tad1Loop(6)

! For numerical routines 
Real(dp) :: gC(239)
logical :: broycheck 
Real(dp) :: broyx(4)

If (HighScaleModel.Eq."LOW") Then 
mlHd2(1) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(1)) - 8*Tad1Loop(4) + g1**2*vd**2*vL(1) +              & 
&  g2**2*vd**2*vL(1) - g1**2*vu**2*vL(1) - g2**2*vu**2*vL(1) + 8*ml2(1,1)*vL(1) +        & 
&  g1**2*vL(1)**3 + g2**2*vL(1)**3 + 4*ml2(1,2)*vL(2) + 4*ml2(2,1)*vL(2) +               & 
&  g1**2*vL(1)*vL(2)**2 + g2**2*vL(1)*vL(2)**2 + 4*ml2(1,3)*vL(3) + 4*ml2(3,             & 
& 1)*vL(3) + g1**2*vL(1)*vL(3)**2 + g2**2*vL(1)*vL(3)**2 + 2*vR**2*vu*Conjg(kap)*Yv(1) - & 
&  2*vd*vR**2*Conjg(lam)*Yv(1) - 2*vd*vu**2*Conjg(lam)*Yv(1) + 2*vR**2*Conjg(Yv(2))*vL(2)*Yv(1) +& 
&  2*vu**2*Conjg(Yv(2))*vL(2)*Yv(1) + 2*vR**2*Conjg(Yv(3))*vL(3)*Yv(1) + 2*vu**2*Conjg(Yv(3))*vL(3)*Yv(1) +& 
&  2*Conjg(Yv(1))*(vu**2*(-(vd*lam) + 2*vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) +       & 
&  vR**2*(vu*kap - vd*lam + 2*vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(1))/(8._dp*vd)
mlHd2(2) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(2)) - 8*Tad1Loop(5) + 4*ml2(1,2)*vL(1) +               & 
&  4*ml2(2,1)*vL(1) + g1**2*vd**2*vL(2) + g2**2*vd**2*vL(2) - g1**2*vu**2*vL(2) -        & 
&  g2**2*vu**2*vL(2) + 8*ml2(2,2)*vL(2) + g1**2*vL(1)**2*vL(2) + g2**2*vL(1)**2*vL(2) +  & 
&  g1**2*vL(2)**3 + g2**2*vL(2)**3 + 4*ml2(2,3)*vL(3) + 4*ml2(3,2)*vL(3) +               & 
&  g1**2*vL(2)*vL(3)**2 + g2**2*vL(2)*vL(3)**2 + 2*vR**2*vu*Conjg(kap)*Yv(2) -           & 
&  2*vd*vR**2*Conjg(lam)*Yv(2) - 2*vd*vu**2*Conjg(lam)*Yv(2) + 2*vR**2*Conjg(Yv(1))*vL(1)*Yv(2) +& 
&  2*vu**2*Conjg(Yv(1))*vL(1)*Yv(2) + 2*vR**2*Conjg(Yv(3))*vL(3)*Yv(2) + 2*vu**2*Conjg(Yv(3))*vL(3)*Yv(2) +& 
&  2*Conjg(Yv(2))*(vu**2*(-(vd*lam) + vL(1)*Yv(1) + 2*vL(2)*Yv(2) + vL(3)*Yv(3)) +       & 
&  vR**2*(vu*kap - vd*lam + vL(1)*Yv(1) + 2*vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(2))/(8._dp*vd)
mlHd2(3) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(3)) - 8*Tad1Loop(6) + 4*ml2(1,3)*vL(1) +               & 
&  4*ml2(3,1)*vL(1) + 4*ml2(2,3)*vL(2) + 4*ml2(3,2)*vL(2) + g1**2*vd**2*vL(3) +          & 
&  g2**2*vd**2*vL(3) - g1**2*vu**2*vL(3) - g2**2*vu**2*vL(3) + 8*ml2(3,3)*vL(3) +        & 
&  g1**2*vL(1)**2*vL(3) + g2**2*vL(1)**2*vL(3) + g1**2*vL(2)**2*vL(3) + g2**2*vL(2)**2*vL(3) +& 
&  g1**2*vL(3)**3 + g2**2*vL(3)**3 + 2*vR**2*vu*Conjg(kap)*Yv(3) - 2*vd*vR**2*Conjg(lam)*Yv(3) -& 
&  2*vd*vu**2*Conjg(lam)*Yv(3) + 2*vR**2*Conjg(Yv(1))*vL(1)*Yv(3) + 2*vu**2*Conjg(Yv(1))*vL(1)*Yv(3) +& 
&  2*vR**2*Conjg(Yv(2))*vL(2)*Yv(3) + 2*vu**2*Conjg(Yv(2))*vL(2)*Yv(3) + 2*Conjg(Yv(3))*(vu**2*(-& 
& (vd*lam) + vL(1)*Yv(1) + vL(2)*Yv(2) + 2*vL(3)*Yv(3)) + vR**2*(vu*kap - vd*lam +       & 
&  vL(1)*Yv(1) + vL(2)*Yv(2) + 2*vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(3))/(8._dp*vd)
mHd2 = (-(g1**2*vd**4) - g2**2*vd**4 + g1**2*vd**2*vu**2 + g2**2*vd**2*vu**2 +               & 
&  2*vd*(-2*vd*vu**2*lam + vR**2*(vu*kap - 2*vd*lam))*Conjg(lam) + 2*sqrt(2._dp)*vd*vR*vu*Conjg(Tlam) +& 
&  2*sqrt(2._dp)*vd*vR*vu*Tlam + 8*vd*Tad1Loop(1) + 2*vR**2*vu*kap*Conjg(Yv(1))*vL(1) +  & 
&  2*sqrt(2._dp)*vR*vu*Conjg(Tv(1))*vL(1) - 8*Tad1Loop(4)*vL(1) - g1**2*vu**2*vL(1)**2 - & 
&  g2**2*vu**2*vL(1)**2 + 8*ml2(1,1)*vL(1)**2 + g1**2*vL(1)**4 + g2**2*vL(1)**4 +        & 
&  2*vR**2*vu*kap*Conjg(Yv(2))*vL(2) + 2*sqrt(2._dp)*vR*vu*Conjg(Tv(2))*vL(2) -          & 
&  8*Tad1Loop(5)*vL(2) + 8*ml2(1,2)*vL(1)*vL(2) + 8*ml2(2,1)*vL(1)*vL(2) -               & 
&  g1**2*vu**2*vL(2)**2 - g2**2*vu**2*vL(2)**2 + 8*ml2(2,2)*vL(2)**2 + 2*g1**2*vL(1)**2*vL(2)**2 +& 
&  2*g2**2*vL(1)**2*vL(2)**2 + g1**2*vL(2)**4 + g2**2*vL(2)**4 + 2*vR**2*vu*kap*Conjg(Yv(3))*vL(3) +& 
&  2*sqrt(2._dp)*vR*vu*Conjg(Tv(3))*vL(3) - 8*Tad1Loop(6)*vL(3) + 8*ml2(1,               & 
& 3)*vL(1)*vL(3) + 8*ml2(3,1)*vL(1)*vL(3) + 8*ml2(2,3)*vL(2)*vL(3) + 8*ml2(3,            & 
& 2)*vL(2)*vL(3) - g1**2*vu**2*vL(3)**2 - g2**2*vu**2*vL(3)**2 + 8*ml2(3,3)*vL(3)**2 +   & 
&  2*g1**2*vL(1)**2*vL(3)**2 + 2*g2**2*vL(1)**2*vL(3)**2 + 2*g1**2*vL(2)**2*vL(3)**2 +   & 
&  2*g2**2*vL(2)**2*vL(3)**2 + g1**2*vL(3)**4 + g2**2*vL(3)**4 + 4*vR**2*Conjg(Yv(1))*vL(1)**2*Yv(1) +& 
&  4*vu**2*Conjg(Yv(1))*vL(1)**2*Yv(1) + 4*vR**2*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) +        & 
&  4*vu**2*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) + 4*vR**2*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) +     & 
&  4*vu**2*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) + 4*vR**2*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) +     & 
&  4*vu**2*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) + 4*vR**2*Conjg(Yv(2))*vL(2)**2*Yv(2) +        & 
&  4*vu**2*Conjg(Yv(2))*vL(2)**2*Yv(2) + 4*vR**2*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) +        & 
&  4*vu**2*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) + 4*vR**2*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) +     & 
&  4*vu**2*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) + 4*vR**2*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) +     & 
&  4*vu**2*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) + 4*vR**2*Conjg(Yv(3))*vL(3)**2*Yv(3) +        & 
&  4*vu**2*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR**2*vu*Conjg(kap)*(vd*lam + vL(1)*Yv(1) +   & 
&  vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*vu*vL(1)*Tv(1) + 2*sqrt(2._dp)*vR*vu*vL(2)*Tv(2) +& 
&  2*sqrt(2._dp)*vR*vu*vL(3)*Tv(3))/(8._dp*vd**2)
mHu2 = (g1**2*vd**2*vu + g2**2*vd**2*vu - g1**2*vu**3 - g2**2*vu**3 + 2*sqrt(2._dp)*vd*vR*Conjg(Tlam) +& 
&  2*sqrt(2._dp)*vd*vR*Tlam + 8*Tad1Loop(2) - 2*vR**2*kap*Conjg(Yv(1))*vL(1) +           & 
&  4*vd*vu*lam*Conjg(Yv(1))*vL(1) - 2*sqrt(2._dp)*vR*Conjg(Tv(1))*vL(1) + g1**2*vu*vL(1)**2 +& 
&  g2**2*vu*vL(1)**2 - 2*vR**2*kap*Conjg(Yv(2))*vL(2) + 4*vd*vu*lam*Conjg(Yv(2))*vL(2) - & 
&  2*sqrt(2._dp)*vR*Conjg(Tv(2))*vL(2) + g1**2*vu*vL(2)**2 + g2**2*vu*vL(2)**2 -         & 
&  2*vR**2*kap*Conjg(Yv(3))*vL(3) + 4*vd*vu*lam*Conjg(Yv(3))*vL(3) - 2*sqrt(2._dp)*vR*Conjg(Tv(3))*vL(3) +& 
&  g1**2*vu*vL(3)**2 + g2**2*vu*vL(3)**2 - 4*vR**2*vu*Conjg(Yv(1))*Yv(1) -               & 
&  4*vu*Conjg(Yv(1))*vL(1)**2*Yv(1) - 4*vu*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) -              & 
&  4*vu*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) - 4*vR**2*vu*Conjg(Yv(2))*Yv(2) - 4*vu*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) -& 
&  4*vu*Conjg(Yv(2))*vL(2)**2*Yv(2) - 4*vu*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) -              & 
&  4*vR**2*vu*Conjg(Yv(3))*Yv(3) - 4*vu*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) - 4*vu*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) -& 
&  4*vu*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR**2*Conjg(kap)*(vd*lam - vL(1)*Yv(1) -         & 
&  vL(2)*Yv(2) - vL(3)*Yv(3)) + Conjg(lam)*(-4*vd**2*vu*lam - 4*vR**2*vu*lam +           & 
&  2*vd*(vR**2*kap + 2*vu*(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)))) - 2*sqrt(2._dp)*vR*vL(1)*Tv(1) -& 
&  2*sqrt(2._dp)*vR*vL(2)*Tv(2) - 2*sqrt(2._dp)*vR*vL(3)*Tv(3))/(8._dp*vu)
mv2 = -(sqrt(2._dp)*vR**2*Conjg(Tk) - sqrt(2._dp)*vd*vu*Conjg(Tlam) + sqrt(2._dp)*vR**2*Tk -& 
&  sqrt(2._dp)*vd*vu*Tlam - 4*Tad1Loop(3) + 2*vR*vu*kap*Conjg(Yv(1))*vL(1) -             & 
&  2*vd*vR*lam*Conjg(Yv(1))*vL(1) + sqrt(2._dp)*vu*Conjg(Tv(1))*vL(1) + 2*vR*vu*kap*Conjg(Yv(2))*vL(2) -& 
&  2*vd*vR*lam*Conjg(Yv(2))*vL(2) + sqrt(2._dp)*vu*Conjg(Tv(2))*vL(2) + 2*vR*vu*kap*Conjg(Yv(3))*vL(3) -& 
&  2*vd*vR*lam*Conjg(Yv(3))*vL(3) + sqrt(2._dp)*vu*Conjg(Tv(3))*vL(3) + 2*vR*vu**2*Conjg(Yv(1))*Yv(1) +& 
&  2*vR*Conjg(Yv(1))*vL(1)**2*Yv(1) + 2*vR*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) +              & 
&  2*vR*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) + 2*vR*vu**2*Conjg(Yv(2))*Yv(2) + 2*vR*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) +& 
&  2*vR*Conjg(Yv(2))*vL(2)**2*Yv(2) + 2*vR*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) +              & 
&  2*vR*vu**2*Conjg(Yv(3))*Yv(3) + 2*vR*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) + 2*vR*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) +& 
&  2*vR*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR*Conjg(lam)*(vd**2*lam + vu**2*lam -           & 
&  vd*(vu*kap + vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*vR*Conjg(kap)*(2*vR**2*kap +& 
&  vu*(-(vd*lam) + vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + sqrt(2._dp)*vu*vL(1)*Tv(1) +& 
&  sqrt(2._dp)*vu*vL(2)*Tv(2) + sqrt(2._dp)*vu*vL(3)*Tv(3))/(4._dp*vR)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(mlHd2(1),dp).ne.Real(mlHd2(1),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(1)" 
   Call TerminateProgram  
 End If 
 If (Real(mlHd2(2),dp).ne.Real(mlHd2(2),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(2)" 
   Call TerminateProgram  
 End If 
 If (Real(mlHd2(3),dp).ne.Real(mlHd2(3),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(3)" 
   Call TerminateProgram  
 End If 
 If (mHd2.ne.mHd2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mHd2" 
   Call TerminateProgram  
 End If 
 If (mHu2.ne.mHu2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mHu2" 
   Call TerminateProgram  
 End If 
 If (mv2.ne.mv2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mv2" 
   Call TerminateProgram  
 End If 
 Else 
mlHd2(1) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(1)) - 8*Tad1Loop(4) + g1**2*vd**2*vL(1) +              & 
&  g2**2*vd**2*vL(1) - g1**2*vu**2*vL(1) - g2**2*vu**2*vL(1) + 8*ml2(1,1)*vL(1) +        & 
&  g1**2*vL(1)**3 + g2**2*vL(1)**3 + 4*ml2(1,2)*vL(2) + 4*ml2(2,1)*vL(2) +               & 
&  g1**2*vL(1)*vL(2)**2 + g2**2*vL(1)*vL(2)**2 + 4*ml2(1,3)*vL(3) + 4*ml2(3,             & 
& 1)*vL(3) + g1**2*vL(1)*vL(3)**2 + g2**2*vL(1)*vL(3)**2 + 2*vR**2*vu*Conjg(kap)*Yv(1) - & 
&  2*vd*vR**2*Conjg(lam)*Yv(1) - 2*vd*vu**2*Conjg(lam)*Yv(1) + 2*vR**2*Conjg(Yv(2))*vL(2)*Yv(1) +& 
&  2*vu**2*Conjg(Yv(2))*vL(2)*Yv(1) + 2*vR**2*Conjg(Yv(3))*vL(3)*Yv(1) + 2*vu**2*Conjg(Yv(3))*vL(3)*Yv(1) +& 
&  2*Conjg(Yv(1))*(vu**2*(-(vd*lam) + 2*vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) +       & 
&  vR**2*(vu*kap - vd*lam + 2*vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(1))/(8._dp*vd)
mlHd2(2) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(2)) - 8*Tad1Loop(5) + 4*ml2(1,2)*vL(1) +               & 
&  4*ml2(2,1)*vL(1) + g1**2*vd**2*vL(2) + g2**2*vd**2*vL(2) - g1**2*vu**2*vL(2) -        & 
&  g2**2*vu**2*vL(2) + 8*ml2(2,2)*vL(2) + g1**2*vL(1)**2*vL(2) + g2**2*vL(1)**2*vL(2) +  & 
&  g1**2*vL(2)**3 + g2**2*vL(2)**3 + 4*ml2(2,3)*vL(3) + 4*ml2(3,2)*vL(3) +               & 
&  g1**2*vL(2)*vL(3)**2 + g2**2*vL(2)*vL(3)**2 + 2*vR**2*vu*Conjg(kap)*Yv(2) -           & 
&  2*vd*vR**2*Conjg(lam)*Yv(2) - 2*vd*vu**2*Conjg(lam)*Yv(2) + 2*vR**2*Conjg(Yv(1))*vL(1)*Yv(2) +& 
&  2*vu**2*Conjg(Yv(1))*vL(1)*Yv(2) + 2*vR**2*Conjg(Yv(3))*vL(3)*Yv(2) + 2*vu**2*Conjg(Yv(3))*vL(3)*Yv(2) +& 
&  2*Conjg(Yv(2))*(vu**2*(-(vd*lam) + vL(1)*Yv(1) + 2*vL(2)*Yv(2) + vL(3)*Yv(3)) +       & 
&  vR**2*(vu*kap - vd*lam + vL(1)*Yv(1) + 2*vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(2))/(8._dp*vd)
mlHd2(3) = -(2*sqrt(2._dp)*vR*vu*Conjg(Tv(3)) - 8*Tad1Loop(6) + 4*ml2(1,3)*vL(1) +               & 
&  4*ml2(3,1)*vL(1) + 4*ml2(2,3)*vL(2) + 4*ml2(3,2)*vL(2) + g1**2*vd**2*vL(3) +          & 
&  g2**2*vd**2*vL(3) - g1**2*vu**2*vL(3) - g2**2*vu**2*vL(3) + 8*ml2(3,3)*vL(3) +        & 
&  g1**2*vL(1)**2*vL(3) + g2**2*vL(1)**2*vL(3) + g1**2*vL(2)**2*vL(3) + g2**2*vL(2)**2*vL(3) +& 
&  g1**2*vL(3)**3 + g2**2*vL(3)**3 + 2*vR**2*vu*Conjg(kap)*Yv(3) - 2*vd*vR**2*Conjg(lam)*Yv(3) -& 
&  2*vd*vu**2*Conjg(lam)*Yv(3) + 2*vR**2*Conjg(Yv(1))*vL(1)*Yv(3) + 2*vu**2*Conjg(Yv(1))*vL(1)*Yv(3) +& 
&  2*vR**2*Conjg(Yv(2))*vL(2)*Yv(3) + 2*vu**2*Conjg(Yv(2))*vL(2)*Yv(3) + 2*Conjg(Yv(3))*(vu**2*(-& 
& (vd*lam) + vL(1)*Yv(1) + vL(2)*Yv(2) + 2*vL(3)*Yv(3)) + vR**2*(vu*kap - vd*lam +       & 
&  vL(1)*Yv(1) + vL(2)*Yv(2) + 2*vL(3)*Yv(3))) + 2*sqrt(2._dp)*vR*vu*Tv(3))/(8._dp*vd)
mHd2 = (-(g1**2*vd**4) - g2**2*vd**4 + g1**2*vd**2*vu**2 + g2**2*vd**2*vu**2 +               & 
&  2*vd*(-2*vd*vu**2*lam + vR**2*(vu*kap - 2*vd*lam))*Conjg(lam) + 2*sqrt(2._dp)*vd*vR*vu*Conjg(Tlam) +& 
&  2*sqrt(2._dp)*vd*vR*vu*Tlam + 8*vd*Tad1Loop(1) + 2*vR**2*vu*kap*Conjg(Yv(1))*vL(1) +  & 
&  2*sqrt(2._dp)*vR*vu*Conjg(Tv(1))*vL(1) - 8*Tad1Loop(4)*vL(1) - g1**2*vu**2*vL(1)**2 - & 
&  g2**2*vu**2*vL(1)**2 + 8*ml2(1,1)*vL(1)**2 + g1**2*vL(1)**4 + g2**2*vL(1)**4 +        & 
&  2*vR**2*vu*kap*Conjg(Yv(2))*vL(2) + 2*sqrt(2._dp)*vR*vu*Conjg(Tv(2))*vL(2) -          & 
&  8*Tad1Loop(5)*vL(2) + 8*ml2(1,2)*vL(1)*vL(2) + 8*ml2(2,1)*vL(1)*vL(2) -               & 
&  g1**2*vu**2*vL(2)**2 - g2**2*vu**2*vL(2)**2 + 8*ml2(2,2)*vL(2)**2 + 2*g1**2*vL(1)**2*vL(2)**2 +& 
&  2*g2**2*vL(1)**2*vL(2)**2 + g1**2*vL(2)**4 + g2**2*vL(2)**4 + 2*vR**2*vu*kap*Conjg(Yv(3))*vL(3) +& 
&  2*sqrt(2._dp)*vR*vu*Conjg(Tv(3))*vL(3) - 8*Tad1Loop(6)*vL(3) + 8*ml2(1,               & 
& 3)*vL(1)*vL(3) + 8*ml2(3,1)*vL(1)*vL(3) + 8*ml2(2,3)*vL(2)*vL(3) + 8*ml2(3,            & 
& 2)*vL(2)*vL(3) - g1**2*vu**2*vL(3)**2 - g2**2*vu**2*vL(3)**2 + 8*ml2(3,3)*vL(3)**2 +   & 
&  2*g1**2*vL(1)**2*vL(3)**2 + 2*g2**2*vL(1)**2*vL(3)**2 + 2*g1**2*vL(2)**2*vL(3)**2 +   & 
&  2*g2**2*vL(2)**2*vL(3)**2 + g1**2*vL(3)**4 + g2**2*vL(3)**4 + 4*vR**2*Conjg(Yv(1))*vL(1)**2*Yv(1) +& 
&  4*vu**2*Conjg(Yv(1))*vL(1)**2*Yv(1) + 4*vR**2*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) +        & 
&  4*vu**2*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) + 4*vR**2*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) +     & 
&  4*vu**2*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) + 4*vR**2*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) +     & 
&  4*vu**2*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) + 4*vR**2*Conjg(Yv(2))*vL(2)**2*Yv(2) +        & 
&  4*vu**2*Conjg(Yv(2))*vL(2)**2*Yv(2) + 4*vR**2*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) +        & 
&  4*vu**2*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) + 4*vR**2*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) +     & 
&  4*vu**2*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) + 4*vR**2*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) +     & 
&  4*vu**2*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) + 4*vR**2*Conjg(Yv(3))*vL(3)**2*Yv(3) +        & 
&  4*vu**2*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR**2*vu*Conjg(kap)*(vd*lam + vL(1)*Yv(1) +   & 
&  vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*vu*vL(1)*Tv(1) + 2*sqrt(2._dp)*vR*vu*vL(2)*Tv(2) +& 
&  2*sqrt(2._dp)*vR*vu*vL(3)*Tv(3))/(8._dp*vd**2)
mHu2 = (g1**2*vd**2*vu + g2**2*vd**2*vu - g1**2*vu**3 - g2**2*vu**3 + 2*sqrt(2._dp)*vd*vR*Conjg(Tlam) +& 
&  2*sqrt(2._dp)*vd*vR*Tlam + 8*Tad1Loop(2) - 2*vR**2*kap*Conjg(Yv(1))*vL(1) +           & 
&  4*vd*vu*lam*Conjg(Yv(1))*vL(1) - 2*sqrt(2._dp)*vR*Conjg(Tv(1))*vL(1) + g1**2*vu*vL(1)**2 +& 
&  g2**2*vu*vL(1)**2 - 2*vR**2*kap*Conjg(Yv(2))*vL(2) + 4*vd*vu*lam*Conjg(Yv(2))*vL(2) - & 
&  2*sqrt(2._dp)*vR*Conjg(Tv(2))*vL(2) + g1**2*vu*vL(2)**2 + g2**2*vu*vL(2)**2 -         & 
&  2*vR**2*kap*Conjg(Yv(3))*vL(3) + 4*vd*vu*lam*Conjg(Yv(3))*vL(3) - 2*sqrt(2._dp)*vR*Conjg(Tv(3))*vL(3) +& 
&  g1**2*vu*vL(3)**2 + g2**2*vu*vL(3)**2 - 4*vR**2*vu*Conjg(Yv(1))*Yv(1) -               & 
&  4*vu*Conjg(Yv(1))*vL(1)**2*Yv(1) - 4*vu*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) -              & 
&  4*vu*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) - 4*vR**2*vu*Conjg(Yv(2))*Yv(2) - 4*vu*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) -& 
&  4*vu*Conjg(Yv(2))*vL(2)**2*Yv(2) - 4*vu*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) -              & 
&  4*vR**2*vu*Conjg(Yv(3))*Yv(3) - 4*vu*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) - 4*vu*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) -& 
&  4*vu*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR**2*Conjg(kap)*(vd*lam - vL(1)*Yv(1) -         & 
&  vL(2)*Yv(2) - vL(3)*Yv(3)) + Conjg(lam)*(-4*vd**2*vu*lam - 4*vR**2*vu*lam +           & 
&  2*vd*(vR**2*kap + 2*vu*(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)))) - 2*sqrt(2._dp)*vR*vL(1)*Tv(1) -& 
&  2*sqrt(2._dp)*vR*vL(2)*Tv(2) - 2*sqrt(2._dp)*vR*vL(3)*Tv(3))/(8._dp*vu)
mv2 = -(sqrt(2._dp)*vR**2*Conjg(Tk) - sqrt(2._dp)*vd*vu*Conjg(Tlam) + sqrt(2._dp)*vR**2*Tk -& 
&  sqrt(2._dp)*vd*vu*Tlam - 4*Tad1Loop(3) + 2*vR*vu*kap*Conjg(Yv(1))*vL(1) -             & 
&  2*vd*vR*lam*Conjg(Yv(1))*vL(1) + sqrt(2._dp)*vu*Conjg(Tv(1))*vL(1) + 2*vR*vu*kap*Conjg(Yv(2))*vL(2) -& 
&  2*vd*vR*lam*Conjg(Yv(2))*vL(2) + sqrt(2._dp)*vu*Conjg(Tv(2))*vL(2) + 2*vR*vu*kap*Conjg(Yv(3))*vL(3) -& 
&  2*vd*vR*lam*Conjg(Yv(3))*vL(3) + sqrt(2._dp)*vu*Conjg(Tv(3))*vL(3) + 2*vR*vu**2*Conjg(Yv(1))*Yv(1) +& 
&  2*vR*Conjg(Yv(1))*vL(1)**2*Yv(1) + 2*vR*Conjg(Yv(2))*vL(1)*vL(2)*Yv(1) +              & 
&  2*vR*Conjg(Yv(3))*vL(1)*vL(3)*Yv(1) + 2*vR*vu**2*Conjg(Yv(2))*Yv(2) + 2*vR*Conjg(Yv(1))*vL(1)*vL(2)*Yv(2) +& 
&  2*vR*Conjg(Yv(2))*vL(2)**2*Yv(2) + 2*vR*Conjg(Yv(3))*vL(2)*vL(3)*Yv(2) +              & 
&  2*vR*vu**2*Conjg(Yv(3))*Yv(3) + 2*vR*Conjg(Yv(1))*vL(1)*vL(3)*Yv(3) + 2*vR*Conjg(Yv(2))*vL(2)*vL(3)*Yv(3) +& 
&  2*vR*Conjg(Yv(3))*vL(3)**2*Yv(3) + 2*vR*Conjg(lam)*(vd**2*lam + vu**2*lam -           & 
&  vd*(vu*kap + vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + 2*vR*Conjg(kap)*(2*vR**2*kap +& 
&  vu*(-(vd*lam) + vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3))) + sqrt(2._dp)*vu*vL(1)*Tv(1) +& 
&  sqrt(2._dp)*vu*vL(2)*Tv(2) + sqrt(2._dp)*vu*vL(3)*Tv(3))/(4._dp*vR)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(mlHd2(1),dp).ne.Real(mlHd2(1),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(1)" 
   Call TerminateProgram  
 End If 
 If (Real(mlHd2(2),dp).ne.Real(mlHd2(2),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(2)" 
   Call TerminateProgram  
 End If 
 If (Real(mlHd2(3),dp).ne.Real(mlHd2(3),dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mlHd2(3)" 
   Call TerminateProgram  
 End If 
 If (mHd2.ne.mHd2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mHd2" 
   Call TerminateProgram  
 End If 
 If (mHu2.ne.mHu2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mHu2" 
   Call TerminateProgram  
 End If 
 If (mv2.ne.mv2) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for mv2" 
   Call TerminateProgram  
 End If 
 End if 
End Subroutine SolveTadpoleEquations

Subroutine CalculateTadpoles(g1,g2,g3,Yd,Ye,lam,Yv,Yu,kap,Td,Te,Tlam,Tv,              & 
& Tu,Tk,mq2,ml2,mHd2,mHu2,md2,mu2,me2,mv2,mlHd2,M1,M2,M3,vd,vu,vL,vR,Tad1Loop,           & 
& TadpoleValues)

Real(dp),Intent(in) :: g1,g2,g3,mHd2,mHu2,mv2,mlHd2(3),vd,vu,vL(3),vR

Complex(dp),Intent(in) :: Yd(3,3),Ye(3,3),lam,Yv(3),Yu(3,3),kap,Td(3,3),Te(3,3),Tlam,Tv(3),Tu(3,3),             & 
& Tk,mq2(3,3),ml2(3,3),md2(3,3),mu2(3,3),me2(3,3),M1,M2,M3

Complex(dp), Intent(in) :: Tad1Loop(6)

Real(dp), Intent(out) :: TadpoleValues(6)

TadpoleValues(1) = Real(-Tad1Loop(1) + ((g1**2 + g2**2)*vd**3 + 8*(mlHd2(1)           & 
& *vL(1) + mlHd2(2)*vL(2) + mlHd2(3)*vL(3)) + vd*(8._dp*(mHd2) - g1**2*vu**2 - g2**2*vu**2 + 4*(vR**2 + vu**2)& 
& *lam*Conjg(lam) + (g1**2 + g2**2)*(vL(1)**2 + vL(2)**2 + vL(3)**2)) - 2*(vR*vu*(vR*lam*Conjg(kap)& 
&  + sqrt(2._dp)*Conjg(Tlam) + sqrt(2._dp)*Tlam) + (vR**2 + vu**2)*lam*(Conjg(Yv(1))     & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3)) + Conjg(lam)*(vR**2*vu*kap + (vR**2 + vu**2)& 
& *(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)))))/8._dp,dp) 
TadpoleValues(2) = Real(-Tad1Loop(2) + (8*mHu2*vu - g1**2*vd**2*vu - g2**2*vd**2*vu + g1**2*vu**3 + g2**2*vu**3 - 2*vd*vR**2*lam*Conjg(kap)& 
&  - 2*vd*vR**2*kap*Conjg(lam) + 4*vd**2*vu*lam*Conjg(lam) + 4*vR**2*vu*lam*Conjg(lam)   & 
&  - 2*sqrt(2._dp)*vd*vR*Conjg(Tlam) - 2*sqrt(2._dp)*vd*vR*Tlam + 2*vR**2*kap*(Conjg(Yv(1))& 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3)) - 4*vd*vu*lam*(Conjg(Yv(1))          & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3)) + 2*sqrt(2._dp)*vR*(Conjg(Tv(1))     & 
& *vL(1) + Conjg(Tv(2))*vL(2) + Conjg(Tv(3))*vL(3)) - g1**2*vu*(vL(1)**2 + vL(2)         & 
& **2 + vL(3)**2) - g2**2*vu*(vL(1)**2 + vL(2)**2 + vL(3)**2) + 4*vR**2*vu*(Conjg(Yv(1)) & 
& *Yv(1) + Conjg(Yv(2))*Yv(2) + Conjg(Yv(3))*Yv(3)) + 2*vR**2*Conjg(kap)*(vL(1)          & 
& *Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) - 4*vd*vu*Conjg(lam)*(vL(1)*Yv(1) + vL(2)          & 
& *Yv(2) + vL(3)*Yv(3)) + 4*vu*(Conjg(Yv(1))*vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))   & 
& *vL(3))*(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*(vL(1)            & 
& *Tv(1) + vL(2)*Tv(2) + vL(3)*Tv(3)))/8._dp,dp) 
TadpoleValues(3) = Real(-Tad1Loop(4) + (2*vR**2*vu*kap*Conjg(Yv(1)) - 2*vd*vR**2*lam*Conjg(Yv(1))& 
&  - 2*vd*vu**2*lam*Conjg(Yv(1)) + 2*sqrt(2._dp)*vR*vu*Conjg(Tv(1)) + 8*vd*mlHd2(1)      & 
&  + g1**2*vd**2*vL(1) + g2**2*vd**2*vL(1) - g1**2*vu**2*vL(1) - g2**2*vu**2*vL(1)       & 
&  + 4*(ml2(1,1)*vL(1) + ml2(1,2)*vL(2) + ml2(1,3)*vL(3)) + 4*(ml2(1,1)*vL(1)            & 
&  + ml2(2,1)*vL(2) + ml2(3,1)*vL(3)) + g1**2*vL(1)*(vL(1)**2 + vL(2)**2 + vL(3)         & 
& **2) + g2**2*vL(1)*(vL(1)**2 + vL(2)**2 + vL(3)**2) + 2*vR**2*vu*Conjg(kap)            & 
& *Yv(1) - 2*vd*vR**2*Conjg(lam)*Yv(1) - 2*vd*vu**2*Conjg(lam)*Yv(1) + 2*vR**2*(Conjg(Yv(1))& 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(1) + 2*vu**2*(Conjg(Yv(1))        & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(1) + 2*vR**2*Conjg(Yv(1))         & 
& *(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*vu**2*Conjg(Yv(1))*(vL(1)               & 
& *Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*vu*Tv(1))/8._dp,dp) 
TadpoleValues(4) = Real(-Tad1Loop(5) + (2*vR**2*vu*kap*Conjg(Yv(2)) - 2*vd*vR**2*lam*Conjg(Yv(2))& 
&  - 2*vd*vu**2*lam*Conjg(Yv(2)) + 2*sqrt(2._dp)*vR*vu*Conjg(Tv(2)) + 8*vd*mlHd2(2)      & 
&  + g1**2*vd**2*vL(2) + g2**2*vd**2*vL(2) - g1**2*vu**2*vL(2) - g2**2*vu**2*vL(2)       & 
&  + 4*(ml2(2,1)*vL(1) + ml2(2,2)*vL(2) + ml2(2,3)*vL(3)) + 4*(ml2(1,2)*vL(1)            & 
&  + ml2(2,2)*vL(2) + ml2(3,2)*vL(3)) + g1**2*vL(2)*(vL(1)**2 + vL(2)**2 + vL(3)         & 
& **2) + g2**2*vL(2)*(vL(1)**2 + vL(2)**2 + vL(3)**2) + 2*vR**2*vu*Conjg(kap)            & 
& *Yv(2) - 2*vd*vR**2*Conjg(lam)*Yv(2) - 2*vd*vu**2*Conjg(lam)*Yv(2) + 2*vR**2*(Conjg(Yv(1))& 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(2) + 2*vu**2*(Conjg(Yv(1))        & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(2) + 2*vR**2*Conjg(Yv(2))         & 
& *(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*vu**2*Conjg(Yv(2))*(vL(1)               & 
& *Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*vu*Tv(2))/8._dp,dp) 
TadpoleValues(5) = Real(-Tad1Loop(6) + (2*vR**2*vu*kap*Conjg(Yv(3)) - 2*vd*vR**2*lam*Conjg(Yv(3))& 
&  - 2*vd*vu**2*lam*Conjg(Yv(3)) + 2*sqrt(2._dp)*vR*vu*Conjg(Tv(3)) + 8*vd*mlHd2(3)      & 
&  + g1**2*vd**2*vL(3) + g2**2*vd**2*vL(3) - g1**2*vu**2*vL(3) - g2**2*vu**2*vL(3)       & 
&  + 4*(ml2(1,3)*vL(1) + ml2(2,3)*vL(2) + ml2(3,3)*vL(3)) + 4*(ml2(3,1)*vL(1)            & 
&  + ml2(3,2)*vL(2) + ml2(3,3)*vL(3)) + g1**2*vL(3)*(vL(1)**2 + vL(2)**2 + vL(3)         & 
& **2) + g2**2*vL(3)*(vL(1)**2 + vL(2)**2 + vL(3)**2) + 2*vR**2*vu*Conjg(kap)            & 
& *Yv(3) - 2*vd*vR**2*Conjg(lam)*Yv(3) - 2*vd*vu**2*Conjg(lam)*Yv(3) + 2*vR**2*(Conjg(Yv(1))& 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(3) + 2*vu**2*(Conjg(Yv(1))        & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*Yv(3) + 2*vR**2*Conjg(Yv(3))         & 
& *(vL(1)*Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*vu**2*Conjg(Yv(3))*(vL(1)               & 
& *Yv(1) + vL(2)*Yv(2) + vL(3)*Yv(3)) + 2*sqrt(2._dp)*vR*vu*Tv(3))/8._dp,dp) 
TadpoleValues(6) = Real(-Tad1Loop(3) + (4*vR**3*kap*Conjg(kap) + sqrt(2._dp)          & 
& *vR**2*(Conjg(Tk) + Tk) + 2*vR*(2._dp*(mv2) - vd*vu*lam*Conjg(kap) - vd*vu*kap*Conjg(lam)& 
&  + vd**2*lam*Conjg(lam) + vu**2*lam*Conjg(lam) + (vu*kap - vd*lam)*(Conjg(Yv(1))       & 
& *vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3)) + vu**2*(Conjg(Yv(1))*Yv(1)          & 
&  + Conjg(Yv(2))*Yv(2) + Conjg(Yv(3))*Yv(3)) + (vu*Conjg(kap) - vd*Conjg(lam)           & 
&  + Conjg(Yv(1))*vL(1) + Conjg(Yv(2))*vL(2) + Conjg(Yv(3))*vL(3))*(vL(1)*Yv(1)          & 
&  + vL(2)*Yv(2) + vL(3)*Yv(3))) + sqrt(2._dp)*vu*(-(vd*(Conjg(Tlam) + Tlam))            & 
&  + Conjg(Tv(1))*vL(1) + Conjg(Tv(2))*vL(2) + Conjg(Tv(3))*vL(3) + vL(1)*Tv(1)          & 
&  + vL(2)*Tv(2) + vL(3)*Tv(3)))/4._dp,dp) 
End Subroutine CalculateTadpoles 

End Module Tadpoles_munuSSM 
 
