Module Pole2L_munuSSM 
 
Use Control 
Use Couplings_munuSSM 
Use LoopFunctions 
Use Mathematics 
Use MathematicsQP 
Use Model_Data_munuSSM 
Use StandardModel 
Use SusyMasses_munuSSM 
Use Pole2LFunctions
Contains 
 
Subroutine CalculatePi2S(p2,vd,vu,vR,vL,g1,g2,g3,Yd,Ye,lam,Yv,Yu,kap,Td,              & 
& Te,Tlam,Tv,Tu,Tk,mq2,ml2,mHd2,mHu2,md2,mu2,me2,mv2,mlHd2,M1,M2,M3,kont,tad2L,          & 
& Pi2S,Pi2P)

Implicit None 
Real(dp),Intent(in) :: g1,g2,g3,mHd2,mHu2,mv2,mlHd2(3)

Complex(dp),Intent(in) :: Yd(3,3),Ye(3,3),lam,Yv(3),Yu(3,3),kap,Td(3,3),Te(3,3),Tlam,Tv(3),Tu(3,3),             & 
& Tk,mq2(3,3),ml2(3,3),md2(3,3),mu2(3,3),me2(3,3),M1,M2,M3

Real(dp),Intent(in) :: vd,vu,vR,vL(3)

Real(dp) :: MAh(6),MAh2(6),MCha(5),MCha2(5),MChi(8),MChi2(8),MFd(3),MFd2(3),MFu(3),               & 
& MFu2(3),MGlu,MGlu2,Mhh(6),Mhh2(6),MHpm(8),MHpm2(8),MSd(6),MSd2(6),MSu(6),              & 
& MSu2(6),MVWm,MVWm2,MVZ,MVZ2,TW,ZA(6,6),ZH(6,6),ZP(8,8),ZZ(2,2)

Complex(dp) :: pG,ZER(5,5),ZEL(5,5),ZD(6,6),ZDL(3,3),ZDR(3,3),UV(8,8),ZU(6,6),ZUL(3,3),              & 
& ZUR(3,3),ZW(2,2)

Complex(dp) :: cplAhAhAh(6,6,6),cplAhAhhh(6,6,6),cplAhhhhh(6,6,6),cplAhHpmcHpm(6,8,8),               & 
& cplAhSdcSd(6,6,6),cplAhSucSu(6,6,6),cplhhhhhh(6,6,6),cplhhHpmcHpm(6,8,8),              & 
& cplhhSdcSd(6,6,6),cplhhSucSu(6,6,6),cplHpmSucSd(8,6,6),cplSdcHpmcSu(6,8,6),            & 
& cplSdcSdVG(6,6),cplSucSuVG(6,6),cplVGVGVG,cplcChaChaAhL(5,5,6),cplcChaChaAhR(5,5,6),   & 
& cplChiChiAhL(8,8,6),cplChiChiAhR(8,8,6),cplcFdFdAhL(3,3,6),cplcFdFdAhR(3,3,6),         & 
& cplcFuFuAhL(3,3,6),cplcFuFuAhR(3,3,6),cplChiChacHpmL(8,5,8),cplChiChacHpmR(8,5,8),     & 
& cplChaFucSdL(5,3,6),cplChaFucSdR(5,3,6),cplcChaChahhL(5,5,6),cplcChaChahhR(5,5,6),     & 
& cplcFdChaSuL(3,5,6),cplcFdChaSuR(3,5,6),cplChiChihhL(8,8,6),cplChiChihhR(8,8,6),       & 
& cplChiFdcSdL(8,3,6),cplChiFdcSdR(8,3,6),cplChiFucSuL(8,3,6),cplChiFucSuR(8,3,6),       & 
& cplcChaChiHpmL(5,8,8),cplcChaChiHpmR(5,8,8),cplcFdChiSdL(3,8,6),cplcFdChiSdR(3,8,6),   & 
& cplcFuChiSuL(3,8,6),cplcFuChiSuR(3,8,6),cplGluFdcSdL(3,6),cplGluFdcSdR(3,6),           & 
& cplcFdFdhhL(3,3,6),cplcFdFdhhR(3,3,6),cplcChaFdcSuL(5,3,6),cplcChaFdcSuR(5,3,6),       & 
& cplcFuFdcHpmL(3,3,8),cplcFuFdcHpmR(3,3,8),cplGluFucSuL(3,6),cplGluFucSuR(3,6),         & 
& cplcFuFuhhL(3,3,6),cplcFuFuhhR(3,3,6),cplcFdFuHpmL(3,3,8),cplcFdFuHpmR(3,3,8),         & 
& cplcFdGluSdL(3,6),cplcFdGluSdR(3,6),cplcFuGluSuL(3,6),cplcFuGluSuR(3,6),               & 
& cplcChacFuSdL(5,3,6),cplcChacFuSdR(5,3,6),cplcFdFdVGL(3,3),cplcFdFdVGR(3,3),           & 
& cplcFuFuVGL(3,3),cplcFuFuVGR(3,3),cplGluGluVGL,cplGluGluVGR

Complex(dp) :: cplAhAhAhAh(6,6,6,6),cplAhAhAhhh(6,6,6,6),cplAhAhhhhh(6,6,6,6),cplAhAhHpmcHpm(6,6,8,8),& 
& cplAhAhSdcSd(6,6,6,6),cplAhAhSucSu(6,6,6,6),cplAhhhhhhh(6,6,6,6),cplAhhhHpmcHpm(6,6,8,8),& 
& cplAhhhSdcSd(6,6,6,6),cplAhhhSucSu(6,6,6,6),cplAhHpmSucSd(6,8,6,6),cplAhSdcHpmcSu(6,6,8,6),& 
& cplhhhhhhhh(6,6,6,6),cplhhhhHpmcHpm(6,6,8,8),cplhhhhSdcSd(6,6,6,6),cplhhhhSucSu(6,6,6,6),& 
& cplhhHpmSucSd(6,8,6,6),cplhhSdcHpmcSu(6,6,8,6),cplHpmHpmcHpmcHpm(8,8,8,8),             & 
& cplHpmSdcHpmcSd(8,6,8,6),cplHpmSucHpmcSu(8,6,8,6),cplSdSdcSdcSd(6,6,6,6),              & 
& cplSdSucSdcSu(6,6,6,6),cplSuSucSucSu(6,6,6,6)

Real(dp), Intent(in) :: p2
Integer, Intent(inout):: kont
Integer :: gE1,gE2,i,i1,i2,i3,i4,i5 
Real(dp) :: Qscale,prefactor,funcvalue
complex(dp) :: cplxprefactor
Real(dp)  :: temptad(6)
Real(dp)  :: tempcont(6,6)
Real(dp)  :: runningval(6,6)
Real(dp), Intent(out) :: tad2l(6)
Real(dp), Intent(out) :: Pi2S(6,6)
Real(dp), Intent(out) :: Pi2P(6,6)
complex(dp) :: coup1,coup2,coup3,coup4
complex(dp) :: coup1L,coup1R,coup2l,coup2r,coup3l,coup3r,coup4l,coup4r
real(dp) :: epsFmass
real(dp) :: epscouplings
Real(dp)  :: tempcouplingvector(6)
Real(dp)  :: tempcouplingmatrix(6,6)
logical :: nonzerocoupling


tad2l(:)=0
Pi2S(:,:)=0
Pi2P(:,:)=0
Qscale=getrenormalizationscale()
epsfmass=0._dp
epscouplings=1.0E-6_dp
Call TreeMassesEffPot(MAh,MAh2,MCha,MCha2,MChi,MChi2,MFd,MFd2,MFu,MFu2,               & 
& MGlu,MGlu2,Mhh,Mhh2,MHpm,MHpm2,MSd,MSd2,MSu,MSu2,MVWm,MVWm2,MVZ,MVZ2,pG,               & 
& TW,ZER,ZEL,ZA,ZD,ZDL,ZDR,ZH,UV,ZP,ZU,ZUL,ZUR,ZW,ZZ,vd,vu,vR,vL,g1,g2,g3,               & 
& Yd,Ye,lam,Yv,Yu,kap,Td,Te,Tlam,Tv,Tu,Tk,mq2,ml2,mHd2,mHu2,md2,mu2,me2,mv2,             & 
& mlHd2,M1,M2,M3,.True.,kont)

Call CouplingsFor2LPole3(lam,Tlam,Yv,Tv,kap,Tk,vd,vu,vL,vR,ZA,ZH,Ye,Te,               & 
& ZP,Yd,Td,ZD,Yu,Tu,ZU,g3,ZER,ZEL,UV,ZDL,ZDR,ZUL,ZUR,pG,cplAhAhAh,cplAhAhhh,             & 
& cplAhhhhh,cplAhHpmcHpm,cplAhSdcSd,cplAhSucSu,cplhhhhhh,cplhhHpmcHpm,cplhhSdcSd,        & 
& cplhhSucSu,cplHpmSucSd,cplSdcHpmcSu,cplSdcSdVG,cplSucSuVG,cplVGVGVG,cplcChaChaAhL,     & 
& cplcChaChaAhR,cplChiChiAhL,cplChiChiAhR,cplcFdFdAhL,cplcFdFdAhR,cplcFuFuAhL,           & 
& cplcFuFuAhR,cplChiChacHpmL,cplChiChacHpmR,cplChaFucSdL,cplChaFucSdR,cplcChaChahhL,     & 
& cplcChaChahhR,cplcFdChaSuL,cplcFdChaSuR,cplChiChihhL,cplChiChihhR,cplChiFdcSdL,        & 
& cplChiFdcSdR,cplChiFucSuL,cplChiFucSuR,cplcChaChiHpmL,cplcChaChiHpmR,cplcFdChiSdL,     & 
& cplcFdChiSdR,cplcFuChiSuL,cplcFuChiSuR,cplGluFdcSdL,cplGluFdcSdR,cplcFdFdhhL,          & 
& cplcFdFdhhR,cplcChaFdcSuL,cplcChaFdcSuR,cplcFuFdcHpmL,cplcFuFdcHpmR,cplGluFucSuL,      & 
& cplGluFucSuR,cplcFuFuhhL,cplcFuFuhhR,cplcFdFuHpmL,cplcFdFuHpmR,cplcFdGluSdL,           & 
& cplcFdGluSdR,cplcFuGluSuL,cplcFuGluSuR,cplcChacFuSdL,cplcChacFuSdR,cplcFdFdVGL,        & 
& cplcFdFdVGR,cplcFuFuVGL,cplcFuFuVGR,cplGluGluVGL,cplGluGluVGR)

Call CouplingsFor2LPole4(lam,Yv,kap,ZA,ZH,Ye,ZP,Yd,ZD,Yu,ZU,g3,cplAhAhAhAh,           & 
& cplAhAhAhhh,cplAhAhhhhh,cplAhAhHpmcHpm,cplAhAhSdcSd,cplAhAhSucSu,cplAhhhhhhh,          & 
& cplAhhhHpmcHpm,cplAhhhSdcSd,cplAhhhSucSu,cplAhHpmSucSd,cplAhSdcHpmcSu,cplhhhhhhhh,     & 
& cplhhhhHpmcHpm,cplhhhhSdcSd,cplhhhhSucSu,cplhhHpmSucSd,cplhhSdcHpmcSu,cplHpmHpmcHpmcHpm,& 
& cplHpmSdcHpmcSd,cplHpmSucHpmcSu,cplSdSdcSdcSd,cplSdSucSdcSu,cplSuSucSucSu)

! ----------------------------
! ----- TADPOLE DIAGRAMS -----
! ----------------------------
temptad(:)=0._dp
tempcouplingvector(:)=0._dp
! ----- SCALAR ONLY DIAGRAMS
! ----- Topology T_SSS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhAhhh(i1,i2,i3,gE1)
coup2 = cplAhAhAh(i1,i2,i3)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,i3)
coup2 = cplAhAhhh(i1,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhhhh(i1,gE1,i2,i3)
coup2 = cplAhhhhh(i1,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhHpmcHpm(i1,gE1,i2,i3)
coup2 = cplAhHpmcHpm(i1,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhSdcSd(i1,gE1,i2,i3)
coup2 = cplAhSdcSd(i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),MSd2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhSucSu(i1,gE1,i2,i3)
coup2 = cplAhSucSu(i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MAh2(i1),MSu2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhhhh(gE1,i1,i2,i3)
coup2 = cplhhhhhh(i1,i2,i3)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhHpmcHpm(gE1,i1,i2,i3)
coup2 = cplhhHpmcHpm(i1,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(Mhh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhSdcSd(gE1,i1,i2,i3)
coup2 = cplhhSdcSd(i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(Mhh2(i1),MSd2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhSucSu(gE1,i1,i2,i3)
coup2 = cplhhSucSu(i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(Mhh2(i1),MSu2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,Su,conj[Sd] ----
Do i1=1,8
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmSucSd(gE1,i1,i2,i3)
coup2 = cplSdcHpmcSu(i3,i1,i2)
prefactor=Real(2*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSSS(MHpm2(i1),MSu2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ----- Topology T_SS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhAhAh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),MAh2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),MAh2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),MAh2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhAhAhhh(i1,i3,i3,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MAh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplAhAhhhhh(i3,i3,i1,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(Mhh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(Mhh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(Mhh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(Mhh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplAhAhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MHpm2(i1),MHpm2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhhhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MHpm2(i1),MHpm2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplHpmHpmcHpmcHpm(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MHpm2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplHpmSdcHpmcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MHpm2(i1),MHpm2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Su ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplHpmSucHpmcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MHpm2(i1),MHpm2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplAhAhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSd2(i1),MSd2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhhhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSd2(i1),MSd2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplHpmSdcHpmcSd(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSd2(i1),MSd2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplSdSdcSdcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSd2(i1),MSd2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplSdSucSdcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSd2(i1),MSd2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplAhAhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSu2(i1),MSu2(i2),MAh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhhhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSu2(i1),MSu2(i2),Mhh2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplHpmSucHpmcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSu2(i1),MSu2(i2),MHpm2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplSdSucSdcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSu2(i1),MSu2(i2),MSd2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplSuSucSucSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= TfSS(MSu2(i1),MSu2(i2),MSu2(i3),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
! ----- Topology T_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplAhAhhh(i3,i4,i1)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(i3,i1,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(i3,i4,i1)
coup3 = cplAhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MHpm2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],hh,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(i3,i4,i1)
coup3 = cplhhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MHpm2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplSdcHpmcSu(i3,i1,i4)
coup3 = cplHpmSucSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MHpm2(i1),MHpm2(i2),MSd2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(i3,i4,i1)
coup3 = cplAhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSd2(i1),MSd2(i2),MAh2(i3),MSd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(i3,i4,i1)
coup3 = cplhhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSd2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Hpm,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplHpmSucSd(i3,i4,i1)
coup3 = cplSdcHpmcSu(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSd2(i1),MSd2(i2),MHpm2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(i3,i4,i1)
coup3 = cplAhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSu2(i1),MSu2(i2),MAh2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(i3,i4,i1)
coup3 = cplhhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSu2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Sd,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplSdcHpmcSu(i3,i4,i1)
coup3 = cplHpmSucSd(i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSSSS(MSu2(i1),MSu2(i2),MSd2(i3),MHpm2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
End do
End do
End do
! ----- SCALAR AND VECTOR DIAGRAMS
! ----- Topology T_SV

! ---- Sd,conj[Sd],Sd,VG ----
Do i1=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSV(MSd2(i1),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
! ---- Su,conj[Su],Su,VG ----
Do i1=1,6
tempcouplingvector=0._dp
nonzerocoupling=.false.
Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingvector(gE1)=tempcouplingvector(gE1)+prefactor
nonzerocoupling=.true.
end if
   End Do
if(nonzerocoupling) then 
funcvalue= -1._dp*TfSV(MSu2(i1),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
End do
! ----- FERMION AND SCALAR DIAGRAMS
! ----- Topology T_SSFF

! ---- Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(-1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(-1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(-3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(-3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(-2*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(-1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(-1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(-1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(-3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(-3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Cha,Chi ----
Do i1=1,8
Do i2=1,8
Do i3=1,5
Do i4=1,8
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(-2*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)*MCha(i3)*MChi(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Fd,bar[Fu] ----
Do i1=1,8
Do i2=1,8
Do i3=1,3
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)*MFd(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Sd,conj[Sd],Cha,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)*MCha(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Sd,conj[Sd],Chi,Fd ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)*MChi(i3)*MFd(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Sd,conj[Sd],Fd,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(-8*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)*MFd(i3)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
! ---- Su,conj[Su],Chi,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)*MChi(i3)*MFu(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Su,conj[Su],Fd,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,5
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(-6*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)*MFd(i3)*MCha(i4)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Su,conj[Su],Fu,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFF(MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)
 temptad=temptad+tempcouplingvector*funcvalue
end if
if((MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(-8*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfSSFbFb(MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)*MFu(i3)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
! ----- Topology T_FFFS

! ---- Cha,bar[Cha],Cha,Ah ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,6
if((MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,i4)
coup2R = cplcChaChaAhR(i1,i3,i4)
coup3L = cplcChaChaAhL(i3,i2,i4)
coup3R = cplcChaChaAhR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MCha2(i1),MCha2(i2),MCha2(i3),MAh2(i4),Qscale)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,i4)
coup2R = cplcChaChaAhR(i1,i3,i4)
coup3L = cplcChaChaAhL(i3,i2,i4)
coup3R = cplcChaChaAhR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MCha2(i1),MCha2(i2),MCha2(i3),MAh2(i4),Qscale)*MCha(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,i4)
coup2R = cplcChaChaAhR(i1,i3,i4)
coup3L = cplcChaChaAhL(i3,i2,i4)
coup3R = cplcChaChaAhR(i3,i2,i4)
prefactor=Real(-2*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MCha2(i1),MCha2(i2),MCha2(i3),MAh2(i4),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,hh ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,6
if((MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,i4)
coup2R = cplcChaChahhR(i1,i3,i4)
coup3L = cplcChaChahhL(i3,i2,i4)
coup3R = cplcChaChahhR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MCha2(i1),MCha2(i2),MCha2(i3),Mhh2(i4),Qscale)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,i4)
coup2R = cplcChaChahhR(i1,i3,i4)
coup3L = cplcChaChahhL(i3,i2,i4)
coup3R = cplcChaChahhR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MCha2(i1),MCha2(i2),MCha2(i3),Mhh2(i4),Qscale)*MCha(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,i4)
coup2R = cplcChaChahhR(i1,i3,i4)
coup3L = cplcChaChahhL(i3,i2,i4)
coup3R = cplcChaChahhR(i3,i2,i4)
prefactor=Real(-2*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MCha2(i1),MCha2(i2),MCha2(i3),Mhh2(i4),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Cha,bar[Cha],Chi,Hpm ----
Do i1=1,5
Do i2=1,5
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChiHpmL(i1,i3,i4)
coup2R = cplcChaChiHpmR(i1,i3,i4)
coup3L = cplChiChacHpmL(i3,i2,i4)
coup3R = cplChiChacHpmR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MCha2(i1),MCha2(i2),MChi2(i3),MHpm2(i4),Qscale)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChiHpmL(i1,i3,i4)
coup2R = cplcChaChiHpmR(i1,i3,i4)
coup3L = cplChiChacHpmL(i3,i2,i4)
coup3R = cplChiChacHpmR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MCha2(i1),MCha2(i2),MChi2(i3),MHpm2(i4),Qscale)*MCha(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChiHpmL(i1,i3,i4)
coup2R = cplcChaChiHpmR(i1,i3,i4)
coup3L = cplChiChacHpmL(i3,i2,i4)
coup3R = cplChiChacHpmR(i3,i2,i4)
prefactor=Real(-2*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MCha2(i1),MCha2(i2),MChi2(i3),MHpm2(i4),Qscale)*MCha(i1)*MCha(i2)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Cha,bar[Cha],Fd,conj[Su] ----
Do i1=1,5
Do i2=1,5
Do i3=1,3
Do i4=1,6
if((MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaFdcSuL(i1,i3,i4)
coup2R = cplcChaFdcSuR(i1,i3,i4)
coup3L = cplcFdChaSuL(i3,i2,i4)
coup3R = cplcFdChaSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MCha2(i1),MCha2(i2),MFd2(i3),MSu2(i4),Qscale)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaFdcSuL(i1,i3,i4)
coup2R = cplcChaFdcSuR(i1,i3,i4)
coup3L = cplcFdChaSuL(i3,i2,i4)
coup3R = cplcFdChaSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MCha2(i1),MCha2(i2),MFd2(i3),MSu2(i4),Qscale)*MCha(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaFdcSuL(i1,i3,i4)
coup2R = cplcChaFdcSuR(i1,i3,i4)
coup3L = cplcFdChaSuL(i3,i2,i4)
coup3R = cplcFdChaSuR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MCha2(i1),MCha2(i2),MFd2(i3),MSu2(i4),Qscale)*MCha(i1)*MCha(i2)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Cha,bar[Cha],bar[Fu],Sd ----
Do i1=1,5
Do i2=1,5
Do i3=1,3
Do i4=1,6
if((MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i1,i3,i4)
coup2R = cplcChacFuSdR(i1,i3,i4)
coup3L = cplChaFucSdL(i2,i3,i4)
coup3R = cplChaFucSdR(i2,i3,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MCha2(i1),MCha2(i2),MFu2(i3),MSd2(i4),Qscale)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i1,i3,i4)
coup2R = cplcChacFuSdR(i1,i3,i4)
coup3L = cplChaFucSdL(i2,i3,i4)
coup3R = cplChaFucSdR(i2,i3,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MCha2(i1),MCha2(i2),MFu2(i3),MSd2(i4),Qscale)*MCha(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i1,i3,i4)
coup2R = cplcChacFuSdR(i1,i3,i4)
coup3L = cplChaFucSdL(i2,i3,i4)
coup3R = cplChaFucSdR(i2,i3,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MCha2(i1),MCha2(i2),MFu2(i3),MSd2(i4),Qscale)*MCha(i1)*MCha(i2)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Chi,Chi,Chi,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
if((MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,i4)
coup2R = cplChiChiAhR(i1,i3,i4)
coup3L = cplChiChiAhL(i2,i3,i4)
coup3R = cplChiChiAhR(i2,i3,i4)
prefactor=Real(1*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MChi2(i1),MChi2(i2),MChi2(i3),MAh2(i4),Qscale)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,i4)
coup2R = cplChiChiAhR(i1,i3,i4)
coup3L = cplChiChiAhL(i2,i3,i4)
coup3R = cplChiChiAhR(i2,i3,i4)
prefactor=Real(1*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MChi2(i1),MChi2(i2),MChi2(i3),MAh2(i4),Qscale)*MChi(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,i4)
coup2R = cplChiChiAhR(i1,i3,i4)
coup3L = cplChiChiAhL(i2,i3,i4)
coup3R = cplChiChiAhR(i2,i3,i4)
prefactor=Real(-1*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MChi2(i1),MChi2(i2),MChi2(i3),MAh2(i4),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Chi,Chi,Cha,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,5
Do i4=1,8
if((MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChacHpmL(i1,i3,i4)
coup2R = cplChiChacHpmR(i1,i3,i4)
coup3L = cplcChaChiHpmL(i3,i2,i4)
coup3R = cplcChaChiHpmR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MChi2(i1),MChi2(i2),MCha2(i3),MHpm2(i4),Qscale)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChacHpmL(i1,i3,i4)
coup2R = cplChiChacHpmR(i1,i3,i4)
coup3L = cplcChaChiHpmL(i3,i2,i4)
coup3R = cplcChaChiHpmR(i3,i2,i4)
prefactor=Real(2*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MChi2(i1),MChi2(i2),MCha2(i3),MHpm2(i4),Qscale)*MChi(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChacHpmL(i1,i3,i4)
coup2R = cplChiChacHpmR(i1,i3,i4)
coup3L = cplcChaChiHpmL(i3,i2,i4)
coup3R = cplcChaChiHpmR(i3,i2,i4)
prefactor=Real(-2*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MChi2(i1),MChi2(i2),MCha2(i3),MHpm2(i4),Qscale)*MChi(i1)*MChi(i2)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Chi,Chi,Chi,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
if((MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,i4)
coup2R = cplChiChihhR(i1,i3,i4)
coup3L = cplChiChihhL(i2,i3,i4)
coup3R = cplChiChihhR(i2,i3,i4)
prefactor=Real(1*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MChi2(i1),MChi2(i2),MChi2(i3),Mhh2(i4),Qscale)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,i4)
coup2R = cplChiChihhR(i1,i3,i4)
coup3L = cplChiChihhL(i2,i3,i4)
coup3R = cplChiChihhR(i2,i3,i4)
prefactor=Real(1*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MChi2(i1),MChi2(i2),MChi2(i3),Mhh2(i4),Qscale)*MChi(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,i4)
coup2R = cplChiChihhR(i1,i3,i4)
coup3L = cplChiChihhL(i2,i3,i4)
coup3R = cplChiChihhR(i2,i3,i4)
prefactor=Real(-1*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MChi2(i1),MChi2(i2),MChi2(i3),Mhh2(i4),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Chi,Chi,Fd,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,3
Do i4=1,6
if((MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFdcSdL(i1,i3,i4)
coup2R = cplChiFdcSdR(i1,i3,i4)
coup3L = cplcFdChiSdL(i3,i2,i4)
coup3R = cplcFdChiSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MChi2(i1),MChi2(i2),MFd2(i3),MSd2(i4),Qscale)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFdcSdL(i1,i3,i4)
coup2R = cplChiFdcSdR(i1,i3,i4)
coup3L = cplcFdChiSdL(i3,i2,i4)
coup3R = cplcFdChiSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MChi2(i1),MChi2(i2),MFd2(i3),MSd2(i4),Qscale)*MChi(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFdcSdL(i1,i3,i4)
coup2R = cplChiFdcSdR(i1,i3,i4)
coup3L = cplcFdChiSdL(i3,i2,i4)
coup3R = cplcFdChiSdR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MChi2(i1),MChi2(i2),MFd2(i3),MSd2(i4),Qscale)*MChi(i1)*MChi(i2)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Chi,Chi,Fu,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,3
Do i4=1,6
if((MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFucSuL(i1,i3,i4)
coup2R = cplChiFucSuR(i1,i3,i4)
coup3L = cplcFuChiSuL(i3,i2,i4)
coup3R = cplcFuChiSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MChi2(i1),MChi2(i2),MFu2(i3),MSu2(i4),Qscale)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFucSuL(i1,i3,i4)
coup2R = cplChiFucSuR(i1,i3,i4)
coup3L = cplcFuChiSuL(i3,i2,i4)
coup3R = cplcFuChiSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MChi2(i1),MChi2(i2),MFu2(i3),MSu2(i4),Qscale)*MChi(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiFucSuL(i1,i3,i4)
coup2R = cplChiFucSuR(i1,i3,i4)
coup3L = cplcFuChiSuL(i3,i2,i4)
coup3R = cplcFuChiSuR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MChi2(i1),MChi2(i2),MFu2(i3),MSu2(i4),Qscale)*MChi(i1)*MChi(i2)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,6
if((MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,i4)
coup2R = cplcFdFdAhR(i1,i3,i4)
coup3L = cplcFdFdAhL(i3,i2,i4)
coup3R = cplcFdFdAhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MFd2(i3),MAh2(i4),Qscale)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,i4)
coup2R = cplcFdFdAhR(i1,i3,i4)
coup3L = cplcFdFdAhL(i3,i2,i4)
coup3R = cplcFdFdAhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MFd2(i3),MAh2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,i4)
coup2R = cplcFdFdAhR(i1,i3,i4)
coup3L = cplcFdFdAhL(i3,i2,i4)
coup3R = cplcFdFdAhR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MFd2(i3),MAh2(i4),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Cha,Su ----
Do i1=1,3
Do i2=1,3
Do i3=1,5
Do i4=1,6
if((MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChaSuL(i1,i3,i4)
coup2R = cplcFdChaSuR(i1,i3,i4)
coup3L = cplcChaFdcSuL(i3,i2,i4)
coup3R = cplcChaFdcSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MCha2(i3),MSu2(i4),Qscale)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChaSuL(i1,i3,i4)
coup2R = cplcFdChaSuR(i1,i3,i4)
coup3L = cplcChaFdcSuL(i3,i2,i4)
coup3R = cplcChaFdcSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MCha2(i3),MSu2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChaSuL(i1,i3,i4)
coup2R = cplcFdChaSuR(i1,i3,i4)
coup3L = cplcChaFdcSuL(i3,i2,i4)
coup3R = cplcChaFdcSuR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MCha2(i3),MSu2(i4),Qscale)*MFd(i1)*MFd(i2)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Chi,Sd ----
Do i1=1,3
Do i2=1,3
Do i3=1,8
Do i4=1,6
if((MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChiSdL(i1,i3,i4)
coup2R = cplcFdChiSdR(i1,i3,i4)
coup3L = cplChiFdcSdL(i3,i2,i4)
coup3R = cplChiFdcSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MChi2(i3),MSd2(i4),Qscale)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChiSdL(i1,i3,i4)
coup2R = cplcFdChiSdR(i1,i3,i4)
coup3L = cplChiFdcSdL(i3,i2,i4)
coup3R = cplChiFdcSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MChi2(i3),MSd2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdChiSdL(i1,i3,i4)
coup2R = cplcFdChiSdR(i1,i3,i4)
coup3L = cplChiFdcSdL(i3,i2,i4)
coup3R = cplChiFdcSdR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MChi2(i3),MSd2(i4),Qscale)*MFd(i1)*MFd(i2)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,6
if((MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,i4)
coup2R = cplcFdFdhhR(i1,i3,i4)
coup3L = cplcFdFdhhL(i3,i2,i4)
coup3R = cplcFdFdhhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MFd2(i3),Mhh2(i4),Qscale)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,i4)
coup2R = cplcFdFdhhR(i1,i3,i4)
coup3L = cplcFdFdhhL(i3,i2,i4)
coup3R = cplcFdFdhhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MFd2(i3),Mhh2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,i4)
coup2R = cplcFdFdhhR(i1,i3,i4)
coup3L = cplcFdFdhhL(i3,i2,i4)
coup3R = cplcFdFdhhR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MFd2(i3),Mhh2(i4),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Fu,Hpm ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
if((MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFuHpmL(i1,i3,i4)
coup2R = cplcFdFuHpmR(i1,i3,i4)
coup3L = cplcFuFdcHpmL(i3,i2,i4)
coup3R = cplcFuFdcHpmR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MFu2(i3),MHpm2(i4),Qscale)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFuHpmL(i1,i3,i4)
coup2R = cplcFdFuHpmR(i1,i3,i4)
coup3L = cplcFuFdcHpmL(i3,i2,i4)
coup3R = cplcFuFdcHpmR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MFu2(i3),MHpm2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFuHpmL(i1,i3,i4)
coup2R = cplcFdFuHpmR(i1,i3,i4)
coup3L = cplcFuFdcHpmL(i3,i2,i4)
coup3R = cplcFuFdcHpmR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MFu2(i3),MHpm2(i4),Qscale)*MFd(i1)*MFd(i2)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fd,bar[Fd],Glu,Sd ----
Do i1=1,3
Do i2=1,3
Do i4=1,6
if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdGluSdL(i1,i4)
coup2R = cplcFdGluSdR(i1,i4)
coup3L = cplGluFdcSdL(i2,i4)
coup3R = cplGluFdcSdR(i2,i4)
prefactor=Real(8*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFd2(i1),MFd2(i2),MGlu2,MSd2(i4),Qscale)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdGluSdL(i1,i4)
coup2R = cplcFdGluSdR(i1,i4)
coup3L = cplGluFdcSdL(i2,i4)
coup3R = cplGluFdcSdR(i2,i4)
prefactor=Real(8*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFd2(i1),MFd2(i2),MGlu2,MSd2(i4),Qscale)*MFd(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdGluSdL(i1,i4)
coup2R = cplcFdGluSdR(i1,i4)
coup3L = cplGluFdcSdL(i2,i4)
coup3R = cplGluFdcSdR(i2,i4)
prefactor=Real(-8*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFd2(i1),MFd2(i2),MGlu2,MSd2(i4),Qscale)*MFd(i1)*MFd(i2)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
! ---- Fu,bar[Fu],Fu,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,6
if((MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,i4)
coup2R = cplcFuFuAhR(i1,i3,i4)
coup3L = cplcFuFuAhL(i3,i2,i4)
coup3R = cplcFuFuAhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MFu2(i3),MAh2(i4),Qscale)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,i4)
coup2R = cplcFuFuAhR(i1,i3,i4)
coup3L = cplcFuFuAhL(i3,i2,i4)
coup3R = cplcFuFuAhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MFu2(i3),MAh2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,i4)
coup2R = cplcFuFuAhR(i1,i3,i4)
coup3L = cplcFuFuAhL(i3,i2,i4)
coup3R = cplcFuFuAhR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MFu2(i3),MAh2(i4),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fu,bar[Fu],Chi,Su ----
Do i1=1,3
Do i2=1,3
Do i3=1,8
Do i4=1,6
if((MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuChiSuL(i1,i3,i4)
coup2R = cplcFuChiSuR(i1,i3,i4)
coup3L = cplChiFucSuL(i3,i2,i4)
coup3R = cplChiFucSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MChi2(i3),MSu2(i4),Qscale)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuChiSuL(i1,i3,i4)
coup2R = cplcFuChiSuR(i1,i3,i4)
coup3L = cplChiFucSuL(i3,i2,i4)
coup3R = cplChiFucSuR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MChi2(i3),MSu2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuChiSuL(i1,i3,i4)
coup2R = cplcFuChiSuR(i1,i3,i4)
coup3L = cplChiFucSuL(i3,i2,i4)
coup3R = cplChiFucSuR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MChi2(i3),MSu2(i4),Qscale)*MFu(i1)*MFu(i2)*MChi(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fu,bar[Fu],Fd,conj[Hpm] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
if((MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFdcHpmL(i1,i3,i4)
coup2R = cplcFuFdcHpmR(i1,i3,i4)
coup3L = cplcFdFuHpmL(i3,i2,i4)
coup3R = cplcFdFuHpmR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MFd2(i3),MHpm2(i4),Qscale)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFdcHpmL(i1,i3,i4)
coup2R = cplcFuFdcHpmR(i1,i3,i4)
coup3L = cplcFdFuHpmL(i3,i2,i4)
coup3R = cplcFdFuHpmR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MFd2(i3),MHpm2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFdcHpmL(i1,i3,i4)
coup2R = cplcFuFdcHpmR(i1,i3,i4)
coup3L = cplcFdFuHpmL(i3,i2,i4)
coup3R = cplcFdFuHpmR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MFd2(i3),MHpm2(i4),Qscale)*MFu(i1)*MFu(i2)*MFd(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,6
if((MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,i4)
coup2R = cplcFuFuhhR(i1,i3,i4)
coup3L = cplcFuFuhhL(i3,i2,i4)
coup3R = cplcFuFuhhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MFu2(i3),Mhh2(i4),Qscale)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,i4)
coup2R = cplcFuFuhhR(i1,i3,i4)
coup3L = cplcFuFuhhL(i3,i2,i4)
coup3R = cplcFuFuhhR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MFu2(i3),Mhh2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,i4)
coup2R = cplcFuFuhhR(i1,i3,i4)
coup3L = cplcFuFuhhL(i3,i2,i4)
coup3R = cplcFuFuhhR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MFu2(i3),Mhh2(i4),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Fu,bar[Fu],Glu,Su ----
Do i1=1,3
Do i2=1,3
Do i4=1,6
if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuGluSuL(i1,i4)
coup2R = cplcFuGluSuR(i1,i4)
coup3L = cplGluFucSuL(i2,i4)
coup3R = cplGluFucSuR(i2,i4)
prefactor=Real(8*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MGlu2,MSu2(i4),Qscale)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuGluSuL(i1,i4)
coup2R = cplcFuGluSuR(i1,i4)
coup3L = cplGluFucSuL(i2,i4)
coup3R = cplGluFucSuR(i2,i4)
prefactor=Real(8*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MGlu2,MSu2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuGluSuL(i1,i4)
coup2R = cplcFuGluSuR(i1,i4)
coup3L = cplGluFucSuL(i2,i4)
coup3R = cplGluFucSuR(i2,i4)
prefactor=Real(-8*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MGlu2,MSu2(i4),Qscale)*MFu(i1)*MFu(i2)*MGlu
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
! ---- Fu,bar[Fu],bar[Cha],Sd ----
Do i1=1,3
Do i2=1,3
Do i3=1,5
Do i4=1,6
if((MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i3,i1,i4)
coup2R = cplcChacFuSdR(i3,i1,i4)
coup3L = cplChaFucSdL(i3,i2,i4)
coup3R = cplChaFucSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3R+coup1R*coup2L*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFFbS(MFu2(i1),MFu2(i2),MCha2(i3),MSd2(i4),Qscale)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i3,i1,i4)
coup2R = cplcChacFuSdR(i3,i1,i4)
coup3L = cplChaFucSdL(i3,i2,i4)
coup3R = cplChaFucSdR(i3,i2,i4)
prefactor=Real(6*(coup1L*coup2R*coup3L+coup1R*coup2L*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFFbFS(MFu2(i1),MFu2(i2),MCha2(i3),MSd2(i4),Qscale)*MFu(i2)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcChacFuSdL(i3,i1,i4)
coup2R = cplcChacFuSdR(i3,i1,i4)
coup3L = cplChaFucSdL(i3,i2,i4)
coup3R = cplChaFucSdR(i3,i2,i4)
prefactor=Real(-6*(coup1L*coup2L*coup3L+coup1R*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFbFbFbS(MFu2(i1),MFu2(i2),MCha2(i3),MSd2(i4),Qscale)*MFu(i1)*MFu(i2)*MCha(i3)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
End do
End do
End do
! ----- FERMION AND VECTOR DIAGRAMS
! ----- Topology T_FV

! ---- Fd,bar[Fd],Fd,VG ----
Do i1=1,3
if((MFd(i1).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFdFdhhL(i1,i1,gE1)
coup1R = cplcFdFdhhR(i1,i1,gE1)
coup2=g3
coup3=g3
prefactor=Real(4*(coup1L*coup2*coup3+coup1R*coup2*coup3),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFV(MFd2(i1),Qscale)*MFd(i1)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
! ---- Fu,bar[Fu],Fu,VG ----
Do i1=1,3
if((MFu(i1).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
coup1L = cplcFuFuhhL(i1,i1,gE1)
coup1R = cplcFuFuhhR(i1,i1,gE1)
coup2=g3
coup3=g3
prefactor=Real(4*(coup1L*coup2*coup3+coup1R*coup2*coup3),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingvector(gE1)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingvector(gE1)= 0._dp
 end if
   End Do
if(nonzerocoupling) then 
 funcvalue= -1._dp*TfFV(MFu2(i1),Qscale)*MFu(i1)
 temptad=temptad+tempcouplingvector*funcvalue
end if
end if

End do
! ----------------------------
! ---- Final tadpole result --
temptad=temptad*oo16Pi2*oo16Pi2
tad2L=matmul(temptad,ZH)
! ----------------------------
! ----------------------------
! ------- MASS DIAGRAMS ------
! ----------------------------
tempcont(:,:)=0._dp
tempcouplingmatrix(:,:)=0._dp
! ----- SCALAR ONLY DIAGRAMS
! ----- Topology W_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhhh(i3,i4,i1)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhhh(i3,i1,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplAhHpmcHpm(i3,i4,i1)
coup3 = cplAhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],hh,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplhhHpmcHpm(i3,i4,i1)
coup3 = cplhhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplSdcHpmcSu(i3,i1,i4)
coup3 = cplHpmSucSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplAhSdcSd(i3,i4,i1)
coup3 = cplAhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplhhSdcSd(i3,i4,i1)
coup3 = cplhhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Hpm,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplHpmSucSd(i3,i4,i1)
coup3 = cplSdcHpmcSu(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplAhSucSu(i3,i4,i1)
coup3 = cplAhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplhhSucSu(i3,i4,i1)
coup3 = cplhhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Sd,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplSdcHpmcSu(i3,i4,i1)
coup3 = cplHpmSucSd(i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology X_SSS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhAhAh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2 = cplAhAhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhAhAhhh(i1,i3,i3,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2 = cplAhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhhhhh(i3,i3,i1,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplAhAhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplhhhhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmHpmcHpmcHpm(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmSdcHpmcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Su ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmSucHpmcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplAhAhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplhhhhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplHpmSdcHpmcSd(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplSdSdcSdcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2 = cplSdSucSdcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplAhAhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplhhhhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplHpmSucHpmcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplSdSucSdcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2 = cplSuSucSucSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology Y_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhAhAh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhAhAhhh(i2,i4,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhSucSu(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhAhhhhh(i4,i4,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhhhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhAhAhAh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhAhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhAhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhAhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhAhAhhh(i2,i4,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhSucSu(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhAhhhhh(i4,i4,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhhhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplAhAhHpmcHpm(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplhhhhHpmcHpm(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmHpmcHpmcHpm(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Sd ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSdcHpmcSd(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Su ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSucHpmcSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplAhAhSdcSd(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplhhhhSdcSd(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplHpmSdcHpmcSd(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplSdSdcSdcSd(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplSdSucSdcSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplAhAhSucSu(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplhhhhSucSu(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplHpmSucHpmcSu(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplSdSucSdcSu(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplSuSucSucSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology Z_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i3,i4,gE2)
coup3 = cplAhAhAhAh(i1,i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i3,gE2,i4)
coup3 = cplAhAhAhhh(i1,i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplhhhhhh(gE2,i3,i4)
coup3 = cplAhAhhhhh(i1,i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplhhHpmcHpm(gE2,i3,i4)
coup3 = cplAhAhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplhhSdcSd(gE2,i3,i4)
coup3 = cplAhAhSdcSd(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplAhAhSucSu(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i3,gE2,i4)
coup3 = cplAhAhhhhh(i1,i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplhhhhhh(gE2,i3,i4)
coup3 = cplAhhhhhhh(i1,i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i4)
coup3 = cplAhhhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplhhSdcSd(gE2,i3,i4)
coup3 = cplAhhhSdcSd(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplAhhhSucSu(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i3,i4)
coup3 = cplhhhhhhhh(i1,i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i4)
coup3 = cplhhhhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i4)
coup3 = cplhhhhSdcSd(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplhhhhSucSu(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i4)
coup3 = cplHpmHpmcHpmcHpm(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i4)
coup3 = cplHpmSdcHpmcSd(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Su,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplHpmSucHpmcSu(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i4)
coup3 = cplSdSdcSdcSd(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplSdSucSdcSu(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSd2(i1),MSd2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i4)
coup3 = cplSuSucSucSu(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology1 S_SSS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(i1,i2,i3,gE1)
coup2 = cplAhAhAhhh(i1,i2,i3,gE2)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,i3)
coup2 = cplAhAhhhhh(i1,i2,gE2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,i2,i3)
coup2 = cplAhhhhhhh(i1,gE2,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhHpmcHpm(i1,gE1,i2,i3)
coup2 = cplAhhhHpmcHpm(i1,gE2,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhSdcSd(i1,gE1,i2,i3)
coup2 = cplAhhhSdcSd(i1,gE2,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhSucSu(i1,gE1,i2,i3)
coup2 = cplAhhhSucSu(i1,gE2,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,i1,i2,i3)
coup2 = cplhhhhhhhh(gE2,i1,i2,i3)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,i1,i2,i3)
coup2 = cplhhhhHpmcHpm(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,i1,i2,i3)
coup2 = cplhhhhSdcSd(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,i1,i2,i3)
coup2 = cplhhhhSucSu(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,Su,conj[Sd] ----
Do i1=1,8
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmSucSd(gE1,i1,i2,i3)
coup2 = cplhhSdcHpmcSu(gE2,i3,i1,i2)
prefactor=Real(2*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MHpm2(i1),MSu2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology U_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhAhhh(i1,i3,i4,gE2)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhhhh(i1,i3,gE2,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhhhh(i1,gE2,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhHpmcHpm(i1,gE2,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhSdcSd(i1,gE2,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhSucSu(i1,gE2,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhAhAhhh(i1,i3,i4,gE2)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhAhhhhh(i1,i3,gE2,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhhhh(i1,gE2,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhHpmcHpm(i1,gE2,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhSdcSd(i1,gE2,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhSucSu(i1,gE2,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhAhhhhh(i3,i4,gE2,i1)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhhhh(i3,gE2,i1,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhhhh(gE2,i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhSdcSd(gE2,i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhSucSu(gE2,i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplAhAhhhhh(i3,i4,gE2,i1)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplAhhhhhhh(i3,gE2,i1,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhhhh(gE2,i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhSdcSd(gE2,i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhSucSu(gE2,i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplAhhhHpmcHpm(i3,gE2,i4,i1)
coup3 = cplAhHpmcHpm(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],hh,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhhhHpmcHpm(gE2,i3,i4,i1)
coup3 = cplhhHpmcHpm(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhSdcHpmcSu(gE2,i3,i1,i4)
coup3 = cplHpmSucSd(i2,i4,i3)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplAhhhSdcSd(i3,gE2,i4,i1)
coup3 = cplAhSdcSd(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhhhSdcSd(gE2,i3,i4,i1)
coup3 = cplhhSdcSd(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Hpm,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhHpmSucSd(gE2,i3,i4,i1)
coup3 = cplSdcHpmcSu(i2,i3,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplAhhhSucSu(i3,gE2,i4,i1)
coup3 = cplAhSucSu(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhhhSucSu(gE2,i3,i4,i1)
coup3 = cplhhSucSu(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Sd,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSdcHpmcSu(gE2,i3,i4,i1)
coup3 = cplHpmSucSd(i4,i2,i3)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology V_SSSSS

! ---- Ah,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhAhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplAhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplAhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplAhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhAhhh(i4,i5,i2)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplAhhhhh(i4,i2,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3 = cplhhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplAhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplAhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplAhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i4,i5,i2)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i4,i2,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3 = cplhhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Ah,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplAhHpmcHpm(i4,i2,i5)
coup4 = cplAhHpmcHpm(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MAh2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,hh,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplhhHpmcHpm(i4,i2,i5)
coup4 = cplhhHpmcHpm(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Mhh2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Su,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSucSd(i2,i4,i5)
coup4 = cplSdcHpmcSu(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Ah,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplAhSdcSd(i4,i2,i5)
coup4 = cplAhSdcSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MAh2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,hh,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplhhSdcSd(i4,i2,i5)
coup4 = cplhhSdcSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Mhh2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,conj[Hpm],conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3 = cplSdcHpmcSu(i2,i4,i5)
coup4 = cplHpmSucSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MHpm2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Ah,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplAhSucSu(i4,i2,i5)
coup4 = cplAhSucSu(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MAh2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,hh,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplhhSucSu(i4,i2,i5)
coup4 = cplhhSucSu(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Mhh2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Hpm,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3 = cplHpmSucSd(i4,i2,i5)
coup4 = cplSdcHpmcSu(i5,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MHpm2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- Topology M_SSSSS

! ---- Ah,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplAhAhhh(i2,i4,gE2)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplAhAhhh(i2,i4,gE2)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplAhAhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplAhhhhh(i2,gE2,i4)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhAhhh(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplAhhhhh(i2,gE2,i4)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i5,i2)
coup4 = cplAhAhhh(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i1,i2,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Hpm,Ah,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplhhHpmcHpm(gE2,i2,i4)
coup3 = cplAhHpmcHpm(i1,i5,i2)
coup4 = cplAhHpmcHpm(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Sd,Ah,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplhhSdcSd(gE2,i2,i4)
coup3 = cplAhSdcSd(i1,i5,i2)
coup4 = cplAhSdcSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSd2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Su,Ah,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2 = cplhhSucSu(gE2,i2,i4)
coup3 = cplAhSucSu(i1,i5,i2)
coup4 = cplAhSucSu(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSu2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplAhhhhh(i2,gE2,i4)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplAhhhhh(i2,gE2,i4)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i5,i2)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Hpm,hh,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplhhHpmcHpm(gE2,i2,i4)
coup3 = cplAhHpmcHpm(i1,i5,i2)
coup4 = cplhhHpmcHpm(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Sd,hh,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplhhSdcSd(gE2,i2,i4)
coup3 = cplAhSdcSd(i1,i5,i2)
coup4 = cplhhSdcSd(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Su,hh,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2 = cplhhSucSu(gE2,i2,i4)
coup3 = cplAhSucSu(i1,i5,i2)
coup4 = cplhhSucSu(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i5,i1,i2)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2 = cplhhhhhh(gE2,i2,i4)
coup3 = cplhhhhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Hpm,hh,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2 = cplhhHpmcHpm(gE2,i2,i4)
coup3 = cplhhHpmcHpm(i1,i5,i2)
coup4 = cplhhHpmcHpm(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Sd,hh,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2 = cplhhSdcSd(gE2,i2,i4)
coup3 = cplhhSdcSd(i1,i5,i2)
coup4 = cplhhSdcSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Su,hh,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2 = cplhhSucSu(gE2,i2,i4)
coup3 = cplhhSucSu(i1,i5,i2)
coup4 = cplhhSucSu(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,Su,conj[Hpm],conj[Su],Sd ----
Do i1=1,8
Do i2=1,6
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2 = cplhhSucSu(gE2,i2,i4)
coup3 = cplSdcHpmcSu(i5,i1,i2)
coup4 = cplHpmSucSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MSu2(i2),MHpm2(i3),MSu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],conj[Hpm],Hpm,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2 = cplhhHpmcHpm(gE2,i4,i2)
coup3 = cplAhHpmcHpm(i5,i2,i1)
coup4 = cplAhHpmcHpm(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],conj[Hpm],Hpm,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2 = cplhhHpmcHpm(gE2,i4,i2)
coup3 = cplhhHpmcHpm(i5,i2,i1)
coup4 = cplhhHpmcHpm(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Sd],conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,6
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2 = cplhhSdcSd(gE2,i4,i2)
coup3 = cplSdcHpmcSu(i2,i1,i5)
coup4 = cplHpmSucSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MSd2(i2),MHpm2(i3),MSd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],conj[Sd],Sd,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2 = cplhhSdcSd(gE2,i4,i2)
coup3 = cplAhSdcSd(i5,i2,i1)
coup4 = cplAhSdcSd(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],conj[Sd],Sd,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2 = cplhhSdcSd(gE2,i4,i2)
coup3 = cplhhSdcSd(i5,i2,i1)
coup4 = cplhhSdcSd(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Su],conj[Sd],Su,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2 = cplhhSucSu(gE2,i4,i2)
coup3 = cplHpmSucSd(i5,i2,i1)
coup4 = cplSdcHpmcSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSu2(i2),MSd2(i3),MSu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],conj[Su],Su,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2 = cplhhSucSu(gE2,i4,i2)
coup3 = cplAhSucSu(i5,i2,i1)
coup4 = cplAhSucSu(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],conj[Su],Su,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2 = cplhhSucSu(gE2,i4,i2)
coup3 = cplhhSucSu(i5,i2,i1)
coup4 = cplhhSucSu(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- SCALAR AND VECTOR DIAGRAMS
! ----- Topology W_SSSV 

! ---- Sd,conj[Sd],Sd,VG ----
Do i1=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSV(p2,MSd2(i1),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
! ---- Su,conj[Su],Su,VG ----
Do i1=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSV(p2,MSu2(i1),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
! ----- Topology V_SSSSV 

! ----- Topology M_SSSSV 

! ---- Sd,conj[Sd],conj[Sd],Sd,VG ----
Do i1=1,6
Do i2=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i2,i1)
coup3 = g3
coup4 = g3
prefactor=Real(1*coup1*coup2*coup3*coup4*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSV(p2,MSd2(i1),MSd2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
! ---- Su,conj[Su],conj[Su],Su,VG ----
Do i1=1,6
Do i2=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i2,i1)
coup3 = g3
coup4 = g3
prefactor=Real(1*coup1*coup2*coup3*coup4*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSV(p2,MSu2(i1),MSu2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
! ----- FERMION AND SCALAR DIAGRAMS
! ----- Topology W_SSFF 

! ---- Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(i1,i2,gE1,gE2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhhhh(i1,gE1,gE2,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Cha,Chi ----
Do i1=1,8
Do i2=1,8
Do i3=1,5
Do i4=1,8
if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Fd,bar[Fu] ----
Do i1=1,8
Do i2=1,8
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Cha,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,3
if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Chi,Fd ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Fd,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
if((MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSdcSd(gE1,gE2,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Chi,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Fd,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,5
if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Fu,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
if((MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhSucSu(gE1,gE2,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology M_FFFFS 

! ---- Cha,Chi,bar[Cha],Chi,Hpm ----
Do i1=1,5
Do i2=1,8
Do i3=1,5
Do i4=1,8
Do i5=1,8
if((MCha(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MChi(i2)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MChi(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,Fu,bar[Cha],bar[Fu],Sd ----
Do i1=1,5
Do i2=1,3
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MFu(i2)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MFu(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],bar[Cha],Cha,Ah ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],bar[Cha],Cha,hh ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Fd],bar[Cha],Fd,conj[Su] ----
Do i1=1,5
Do i2=1,3
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MFd(i2)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MFd(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i3,i1,gE1)
coup1R = cplcChaChahhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Cha,Chi,bar[Cha],Hpm ----
Do i1=1,8
Do i2=1,5
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MChi(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MCha(i2)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MCha(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Fd,Chi,bar[Fd],Sd ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MFd(i2)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MFd(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Fu,Chi,bar[Fu],Su ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MFu(i2)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MFu(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i3,gE1)
coup1R = cplChiChihhR(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,Chi,bar[Fd],Chi,Sd ----
Do i1=1,3
Do i2=1,8
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MChi(i2)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MChi(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Cha],bar[Fd],Cha,Su ----
Do i1=1,3
Do i2=1,5
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MCha(i2)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MCha(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],bar[Fd],Fd,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],bar[Fd],Fd,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fu],bar[Fd],Fu,Hpm ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFd(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFu(i2)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i3,i1,gE1)
coup1R = cplcFdFdhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,Cha,bar[Fu],bar[Cha],Sd ----
Do i1=1,3
Do i2=1,5
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MCha(i2)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MCha(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,Chi,bar[Fu],Chi,Su ----
Do i1=1,3
Do i2=1,8
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MChi(i2)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MChi(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fd],bar[Fu],Fd,conj[Hpm] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFu(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFd(i2)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],bar[Fu],Fu,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],bar[Fu],Fu,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i3,i1,gE1)
coup1R = cplcFuFuhhR(i3,i1,gE1)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- Topology M_SFSFF 

! ---- Ah,Cha,Ah,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Chi,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fd,Ah,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fu,Ah,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i3,gE1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Cha,hh,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Chi,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fd,hh,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fu,hh,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Cha,Ah,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Chi,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fd,Ah,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fu,Ah,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i3,gE1,i1)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Cha,hh,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Chi,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fd,hh,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFdFdhhL(i4,i2,gE2)
coup2R = cplcFdFdhhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fu,hh,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,Chi,conj[Hpm],Chi,Cha ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,5
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i2)*MChi(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,Fu,conj[Hpm],bar[Fu],Fd ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i2)*MFu(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuhhL(i4,i2,gE2)
coup2R = cplcFuFuhhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,bar[Cha],conj[Hpm],Cha,Chi ----
Do i1=1,8
Do i2=1,5
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MCha(i2)*MCha(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,bar[Fd],conj[Hpm],Fd,bar[Fu] ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFd(i2)*MFd(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,Chi,conj[Sd],Chi,Fd ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i2)*MChi(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Cha],conj[Sd],Cha,Fu ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i2)*MCha(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcChaChahhL(i2,i4,gE2)
coup2R = cplcChaChahhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Fd],conj[Sd],Fd,Chi ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,8
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MFd(i2)*MFd(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Fd],conj[Sd],Fd,Glu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MFd(i2)*MFd(i4)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(16*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Sd,bar[Fu],conj[Sd],Fu,Cha ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,5
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MFu(i2)*MFu(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,Cha,conj[Su],bar[Cha],Fd ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i2)*MCha(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcChaChahhL(i4,i2,gE2)
coup2R = cplcChaChahhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,Chi,conj[Su],Chi,Fu ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i2)*MChi(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplChiChihhL(i2,i4,gE2)
coup2R = cplChiChihhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fd],conj[Su],Fd,bar[Cha] ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,5
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MFd(i2)*MFd(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFdFdhhL(i2,i4,gE2)
coup2R = cplcFdFdhhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fu],conj[Su],Fu,Chi ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,8
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MFu(i2)*MFu(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fu],conj[Su],Fu,Glu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MFu(i2)*MFu(i4)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(16*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i3)
coup2L = cplcFuFuhhL(i2,i4,gE2)
coup2R = cplcFuFuhhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
! ----- Topology V_SSSFF 

! ---- Ah,Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhAhhh(i1,i3,gE2)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(i1,i2,gE1)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i1,gE1,i2)
coup2 = cplAhhhhh(i1,gE2,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplAhhhhh(i3,gE2,i1)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(i2,gE1,i1)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhhhhh(gE1,i1,i2)
coup2 = cplhhhhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Chi,bar[Cha] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,5
if((MChi(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3L = cplcChaChiHpmL(i5,i4,i2)
coup3R = cplcChaChiHpmR(i5,i4,i2)
coup4L = cplChiChacHpmL(i4,i5,i3)
coup4R = cplChiChacHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3L = cplcChaChiHpmL(i5,i4,i2)
coup3R = cplcChaChiHpmR(i5,i4,i2)
coup4L = cplChiChacHpmL(i4,i5,i3)
coup4R = cplChiChacHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Fu,bar[Fd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3L = cplcFdFuHpmL(i5,i4,i2)
coup3R = cplcFdFuHpmR(i5,i4,i2)
coup4L = cplcFuFdcHpmL(i4,i5,i3)
coup4R = cplcFuFdcHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhHpmcHpm(gE1,i1,i2)
coup2 = cplhhHpmcHpm(gE2,i3,i1)
coup3L = cplcFdFuHpmL(i5,i4,i2)
coup3R = cplcFdFuHpmR(i5,i4,i2)
coup4L = cplcFuFdcHpmL(i4,i5,i3)
coup4R = cplcFuFdcHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Chi,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcFdChiSdL(i5,i4,i2)
coup3R = cplcFdChiSdR(i5,i4,i2)
coup4L = cplChiFdcSdL(i4,i5,i3)
coup4R = cplChiFdcSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcFdChiSdL(i5,i4,i2)
coup3R = cplcFdChiSdR(i5,i4,i2)
coup4L = cplChiFdcSdL(i4,i5,i3)
coup4R = cplChiFdcSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Glu,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i5=1,3
if((MGlu.gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcFdGluSdL(i5,i2)
coup3R = cplcFdGluSdR(i5,i2)
coup4L = cplGluFdcSdL(i5,i3)
coup4R = cplGluFdcSdR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MGlu2,MFd2(i5),Qscale)*MGlu*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcFdGluSdL(i5,i2)
coup3R = cplcFdGluSdR(i5,i2)
coup4L = cplGluFdcSdL(i5,i3)
coup4R = cplGluFdcSdR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MGlu2,MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,bar[Cha],bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcChacFuSdL(i4,i5,i2)
coup3R = cplcChacFuSdR(i4,i5,i2)
coup4L = cplChaFucSdL(i4,i5,i3)
coup4R = cplChaFucSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSdcSd(gE1,i1,i2)
coup2 = cplhhSdcSd(gE2,i3,i1)
coup3L = cplcChacFuSdL(i4,i5,i2)
coup3R = cplcChacFuSdR(i4,i5,i2)
coup4L = cplChaFucSdL(i4,i5,i3)
coup4R = cplChaFucSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Cha,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFdChaSuL(i5,i4,i2)
coup3R = cplcFdChaSuR(i5,i4,i2)
coup4L = cplcChaFdcSuL(i4,i5,i3)
coup4R = cplcChaFdcSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFdChaSuL(i5,i4,i2)
coup3R = cplcFdChaSuR(i5,i4,i2)
coup4L = cplcChaFdcSuL(i4,i5,i3)
coup4R = cplcChaFdcSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Chi,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFuChiSuL(i5,i4,i2)
coup3R = cplcFuChiSuR(i5,i4,i2)
coup4L = cplChiFucSuL(i4,i5,i3)
coup4R = cplChiFucSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFuChiSuL(i5,i4,i2)
coup3R = cplcFuChiSuR(i5,i4,i2)
coup4L = cplChiFucSuL(i4,i5,i3)
coup4R = cplChiFucSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Glu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i5=1,3
if((MGlu.gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFuGluSuL(i5,i2)
coup3R = cplcFuGluSuR(i5,i2)
coup4L = cplGluFucSuL(i5,i3)
coup4R = cplGluFucSuR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MGlu2,MFu2(i5),Qscale)*MGlu*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplhhSucSu(gE1,i1,i2)
coup2 = cplhhSucSu(gE2,i3,i1)
coup3L = cplcFuGluSuL(i5,i2)
coup3R = cplcFuGluSuR(i5,i2)
coup4L = cplGluFucSuL(i5,i3)
coup4R = cplGluFucSuR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MGlu2,MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology V_FFFFS 

! ---- Cha,bar[Cha],Cha,bar[Cha],Ah ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,Chi,conj[Hpm] ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,8
Do i5=1,8
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,Fu,conj[Sd] ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,bar[Cha],hh ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,bar[Fd],Su ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChahhL(i2,i1,gE1)
coup1R = cplcChaChahhR(i2,i1,gE1)
coup2L = cplcChaChahhL(i1,i3,gE2)
coup2R = cplcChaChahhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Cha,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Fd,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Fu,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChihhL(i1,i2,gE1)
coup1R = cplChiChihhR(i1,i2,gE1)
coup2L = cplChiChihhL(i1,i3,gE2)
coup2R = cplChiChihhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fd],Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,Chi,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,Glu,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(16*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(16*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fd],hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Cha],conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fu],conj[Hpm] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i3,gE2)
coup2R = cplcFdFdhhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fu],Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Cha,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Chi,conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Glu,conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(16*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(16*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fu],hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fd],Hpm ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i3,gE2)
coup2R = cplcFuFuhhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- FERMION AND VECTOR DIAGRAMS
! ----- Topology G_FFFFV 

! ---- Fd,bar[Fd],Fd,VG,bar[Fd] ----
Do i1=1,3
Do i2=1,3
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i2,gE2)
coup2R = cplcFdFdhhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2R*coup3*coup4+coup1R*coup2L*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFFV(p2,MFd2(i1),MFd2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdhhL(i2,i1,gE1)
coup1R = cplcFdFdhhR(i2,i1,gE1)
coup2L = cplcFdFdhhL(i1,i2,gE2)
coup2R = cplcFdFdhhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2L*coup3*coup4+coup1R*coup2R*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFbFbV(p2,MFd2(i1),MFd2(i2),Qscale)*MFd(i1)*MFd(i2)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
! ---- Fu,bar[Fu],Fu,VG,bar[Fu] ----
Do i1=1,3
Do i2=1,3
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i2,gE2)
coup2R = cplcFuFuhhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2R*coup3*coup4+coup1R*coup2L*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFFV(p2,MFu2(i1),MFu2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuhhL(i2,i1,gE1)
coup1R = cplcFuFuhhR(i2,i1,gE1)
coup2L = cplcFuFuhhL(i1,i2,gE2)
coup2R = cplcFuFuhhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2L*coup3*coup4+coup1R*coup2R*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFbFbV(p2,MFu2(i1),MFu2(i2),Qscale)*MFu(i1)*MFu(i2)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
! ----- TIDY UP AND SYMMETRISE -----
do gE1=1,6
Pi2S(gE1,gE1)=Pi2S(gE1,gE1)+tempcont(gE1,gE1)*oo16Pi2*oo16Pi2
do gE2=1,gE1-1
Pi2S(gE1,gE2)=Pi2S(gE1,gE2)+0.5_dp*(tempcont(gE1,gE2)+tempcont(gE2,gE1))*oo16Pi2*oo16Pi2
Pi2S(gE2,gE1)=Pi2S(gE1,gE2)
End do
End do
Pi2S = Matmul(Pi2S,ZH)
Pi2S = Matmul(Transpose(ZH),Pi2S)
! ----------------------------
! ------- MASS DIAGRAMS ------
! ----------------------------
tempcont(:,:)=0._dp
tempcouplingmatrix(:,:)=0._dp
! ----- SCALAR ONLY DIAGRAMS
! ----- Topology W_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhAh(i1,i3,i4)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhhh(i1,i3,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhhh(i3,i4,i1)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhhh(i3,i1,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhhh(i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhHpmcHpm(i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhSdcSd(i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhSucSu(i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplAhHpmcHpm(i3,i4,i1)
coup3 = cplAhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],hh,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplhhHpmcHpm(i3,i4,i1)
coup3 = cplhhHpmcHpm(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplSdcHpmcSu(i3,i1,i4)
coup3 = cplHpmSucSd(i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplAhSdcSd(i3,i4,i1)
coup3 = cplAhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplhhSdcSd(i3,i4,i1)
coup3 = cplhhSdcSd(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Hpm,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplHpmSucSd(i3,i4,i1)
coup3 = cplSdcHpmcSu(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplAhSucSu(i3,i4,i1)
coup3 = cplAhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplhhSucSu(i3,i4,i1)
coup3 = cplhhSucSu(i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Sd,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplSdcHpmcSu(i3,i4,i1)
coup3 = cplHpmSucSd(i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology X_SSS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhAhAh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2 = cplAhAhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhAhhh(i1,i3,i3,i2)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2 = cplAhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplAhAhhhhh(i3,i3,i1,i2)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhhhhh(i1,i2,i3,i3)
prefactor=Real(1._dp/4._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhHpmcHpm(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhSdcSd(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2 = cplhhhhSucSu(i1,i2,i3,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplAhAhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplhhhhHpmcHpm(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmHpmcHpmcHpm(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmSdcHpmcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,conj[Hpm],Su ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2 = cplHpmSucHpmcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MHpm2(i1),MHpm2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplAhAhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplhhhhSdcSd(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplHpmSdcHpmcSd(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplSdSdcSdcSd(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Sd,conj[Sd],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2 = cplSdSucSdcSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSd2(i1),MSd2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplAhAhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplhhhhSucSu(i3,i3,i2,i1)
prefactor=Real(1._dp/2._dp*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplHpmSucHpmcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplSdSucSdcSu(i3,i2,i3,i1)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2 = cplSuSucSucSu(i2,i3,i1,i3)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= XfSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology Y_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhAhAh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhAhAhhh(i2,i4,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhSucSu(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhAhhhhh(i4,i4,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhhhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhAhAhAh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhAhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhAhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhAhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhAhAhhh(i2,i4,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhSucSu(i2,i3,i4,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhAhhhhh(i4,i4,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhhhhhhh(i2,i3,i4,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhhhHpmcHpm(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhhhSdcSd(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhhhSucSu(i2,i3,i4,i4)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplAhAhHpmcHpm(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplhhhhHpmcHpm(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmHpmcHpmcHpm(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Sd ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSdcHpmcSd(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Su ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSucHpmcSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplAhAhSdcSd(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplhhhhSdcSd(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplHpmSdcHpmcSd(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplSdSdcSdcSd(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplSdSucSdcSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplAhAhSucSu(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplhhhhSucSu(i4,i4,i2,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplHpmSucHpmcSu(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplSdSucSdcSu(i4,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplSuSucSucSu(i2,i4,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*YfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology Z_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i3,i4)
coup3 = cplAhAhAhAh(i1,i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i3,i4)
coup3 = cplAhAhAhhh(i1,i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i3,i4)
coup3 = cplAhAhhhhh(i1,i2,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i4)
coup3 = cplAhAhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i4)
coup3 = cplAhAhSdcSd(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplAhAhSucSu(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i3,i4)
coup3 = cplAhAhhhhh(i1,i3,i2,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i3,i4)
coup3 = cplAhhhhhhh(i1,i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i4)
coup3 = cplAhhhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i4)
coup3 = cplAhhhSdcSd(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplAhhhSucSu(i1,i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i3,i4)
coup3 = cplhhhhhhhh(i1,i2,i3,i4)
prefactor=Real(1._dp/4._dp*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i4)
coup3 = cplhhhhHpmcHpm(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i4)
coup3 = cplhhhhSdcSd(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplhhhhSucSu(i1,i2,i4,i3)
prefactor=Real(1*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i4)
coup3 = cplHpmHpmcHpmcHpm(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i4)
coup3 = cplHpmSdcHpmcSd(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Su,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplHpmSucHpmcSu(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MHpm2(i1),MHpm2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i4)
coup3 = cplSdSdcSdcSd(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplSdSucSdcSu(i2,i4,i1,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSd2(i1),MSd2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i4)
coup3 = cplSuSucSucSu(i2,i4,i1,i3)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*ZfSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology1 S_SSS

! ---- Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,i1,i2,i3)
coup2 = cplAhAhAhAh(gE2,i1,i2,i3)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,i1,i2,i3)
coup2 = cplAhAhAhhh(gE2,i1,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,i1,i2,i3)
coup2 = cplAhAhhhhh(gE2,i1,i2,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,i1,i2,i3)
coup2 = cplAhAhHpmcHpm(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,i1,i2,i3)
coup2 = cplAhAhSdcSd(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,i1,i2,i3)
coup2 = cplAhAhSucSu(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MAh2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhhhh(gE1,i1,i2,i3)
coup2 = cplAhhhhhhh(gE2,i1,i2,i3)
prefactor=Real(1._dp/6._dp*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,8
Do i3=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhHpmcHpm(gE1,i1,i2,i3)
coup2 = cplAhhhHpmcHpm(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MHpm2(i2),MHpm2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhSdcSd(gE1,i1,i2,i3)
coup2 = cplAhhhSdcSd(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MSd2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhSucSu(gE1,i1,i2,i3)
coup2 = cplAhhhSucSu(gE2,i1,i3,i2)
prefactor=Real(1*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,Mhh2(i1),MSu2(i2),MSu2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Hpm,Su,conj[Sd] ----
Do i1=1,8
Do i2=1,6
Do i3=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmSucSd(gE1,i1,i2,i3)
coup2 = cplAhSdcHpmcSu(gE2,i3,i1,i2)
prefactor=Real(2*coup1*coup2*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= SfSSS(p2,MHpm2(i1),MSu2(i2),MSd2(i3),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology U_SSSS

! ---- Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAhAh(gE2,i1,i3,i4)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAhhh(gE2,i1,i3,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhhhh(gE2,i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhSdcSd(gE2,i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhSucSu(gE2,i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhAhAh(gE2,i1,i3,i4)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhAhhh(gE2,i1,i3,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhhhh(gE2,i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhSdcSd(gE2,i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhSucSu(gE2,i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MAh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhAhhh(gE2,i3,i4,i1)
coup3 = cplAhAhAh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhhhh(gE2,i3,i1,i4)
coup3 = cplAhAhhh(i2,i3,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhhhh(gE2,i1,i3,i4)
coup3 = cplAhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplAhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhSdcSd(gE2,i1,i3,i4)
coup3 = cplAhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhSucSu(gE2,i1,i3,i4)
coup3 = cplAhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),MAh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhAhAhhh(gE2,i3,i4,i1)
coup3 = cplAhAhhh(i3,i4,i2)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),MAh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhAhhhhh(gE2,i3,i1,i4)
coup3 = cplAhhhhh(i3,i2,i4)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhhhh(gE2,i1,i3,i4)
coup3 = cplhhhhhh(i2,i3,i4)
prefactor=Real(1*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhHpmcHpm(gE2,i1,i3,i4)
coup3 = cplhhHpmcHpm(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MHpm2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhSdcSd(gE2,i1,i3,i4)
coup3 = cplhhSdcSd(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MSd2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhSucSu(gE2,i1,i3,i4)
coup3 = cplhhSucSu(i2,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,Mhh2(i1),Mhh2(i2),MSu2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Ah,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhAhHpmcHpm(gE2,i3,i4,i1)
coup3 = cplAhHpmcHpm(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],hh,Hpm ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhhhHpmcHpm(gE2,i3,i4,i1)
coup3 = cplhhHpmcHpm(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhSdcHpmcSu(gE2,i3,i1,i4)
coup3 = cplHpmSucSd(i2,i4,i3)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MHpm2(i1),MHpm2(i2),MSd2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Ah,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhAhSdcSd(gE2,i3,i4,i1)
coup3 = cplAhSdcSd(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),MAh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],hh,Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhhhSdcSd(gE2,i3,i4,i1)
coup3 = cplhhSdcSd(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Hpm,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhHpmSucSd(gE2,i3,i4,i1)
coup3 = cplSdcHpmcSu(i2,i3,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSd2(i1),MSd2(i2),MHpm2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Ah,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhAhSucSu(gE2,i3,i4,i1)
coup3 = cplAhSucSu(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),MAh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],hh,Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhhhSucSu(gE2,i3,i4,i1)
coup3 = cplhhSucSu(i3,i2,i4)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Sd,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSdcHpmcSu(gE2,i3,i4,i1)
coup3 = cplHpmSucSd(i4,i2,i3)
prefactor=Real(4*coup1*coup2*coup3*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*UfSSSS(p2,MSu2(i1),MSu2(i2),MSd2(i3),MHpm2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology V_SSSSS

! ---- Ah,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhAhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplAhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplAhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplAhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i4,i5,i2)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i4,i2,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3 = cplhhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplAhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplAhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplAhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhAhAh(i2,i4,i5)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i2,i4,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhAhhh(i4,i5,i2)
coup4 = cplAhAhhh(i4,i5,i3)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplAhhhhh(i4,i2,i5)
coup4 = cplAhhhhh(i4,i3,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhhhhh(i2,i4,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Hpm,conj[Hpm] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhHpmcHpm(i2,i4,i5)
coup4 = cplhhHpmcHpm(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Sd,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhSdcSd(i2,i4,i5)
coup4 = cplhhSdcSd(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Su,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3 = cplhhSucSu(i2,i4,i5)
coup4 = cplhhSucSu(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Ah,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplAhHpmcHpm(i4,i2,i5)
coup4 = cplAhHpmcHpm(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MAh2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,hh,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplhhHpmcHpm(i4,i2,i5)
coup4 = cplhhHpmcHpm(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),Mhh2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Su,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3 = cplHpmSucSd(i2,i4,i5)
coup4 = cplSdcHpmcSu(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MSu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Ah,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplAhSdcSd(i4,i2,i5)
coup4 = cplAhSdcSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MAh2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,hh,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplhhSdcSd(i4,i2,i5)
coup4 = cplhhSdcSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),Mhh2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,conj[Hpm],conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3 = cplSdcHpmcSu(i2,i4,i5)
coup4 = cplHpmSucSd(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MHpm2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Ah,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplAhSucSu(i4,i2,i5)
coup4 = cplAhSucSu(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MAh2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,hh,conj[Su] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplhhSucSu(i4,i2,i5)
coup4 = cplhhSucSu(i4,i5,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),Mhh2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Hpm,conj[Sd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3 = cplHpmSucSd(i4,i2,i5)
coup4 = cplSdcHpmcSu(i5,i4,i3)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= VfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MHpm2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- Topology M_SSSSS

! ---- Ah,Ah,Ah,Ah,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhAhAh(gE2,i2,i4)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhAhAh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Ah,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhAhAh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplAhAhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),MAh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhAhhh(gE2,i2,i4)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhAhhh(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhAhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i5,i2)
coup4 = cplAhAhhh(i3,i5,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,Ah,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i1,i2,i5)
coup4 = cplAhhhhh(i3,i4,i5)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),MAh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Hpm,Ah,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhHpmcHpm(gE2,i2,i4)
coup3 = cplAhHpmcHpm(i1,i5,i2)
coup4 = cplAhHpmcHpm(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MHpm2(i2),MAh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Sd,Ah,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i2,i4)
coup3 = cplAhSdcSd(i1,i5,i2)
coup4 = cplAhSdcSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSd2(i2),MAh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Su,Ah,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i2,i4)
coup3 = cplAhSucSu(i1,i5,i2)
coup4 = cplAhSucSu(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSu2(i2),MAh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhAhhh(gE2,i2,i4)
coup3 = cplAhAhAh(i1,i2,i5)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhAhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MAh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplAhAhhh(i1,i5,i2)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Hpm,hh,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhHpmcHpm(gE2,i2,i4)
coup3 = cplAhHpmcHpm(i1,i5,i2)
coup4 = cplhhHpmcHpm(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Sd,hh,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i2,i4)
coup3 = cplAhSdcSd(i1,i5,i2)
coup4 = cplhhSdcSd(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Su,hh,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i2,i4)
coup3 = cplAhSucSu(i1,i5,i2)
coup4 = cplhhSucSu(i3,i4,i5)
prefactor=Real(4*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MAh2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplAhhhhh(i5,i1,i2)
coup4 = cplAhhhhh(i5,i3,i4)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,hh,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2 = cplAhhhhh(gE2,i2,i4)
coup3 = cplhhhhhh(i1,i2,i5)
coup4 = cplhhhhhh(i3,i4,i5)
prefactor=Real(1._dp/2._dp*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),Mhh2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Hpm,hh,conj[Hpm],Hpm ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2 = cplAhHpmcHpm(gE2,i2,i4)
coup3 = cplhhHpmcHpm(i1,i5,i2)
coup4 = cplhhHpmcHpm(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MHpm2(i2),Mhh2(i3),MHpm2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Sd,hh,conj[Sd],Sd ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i2,i4)
coup3 = cplhhSdcSd(i1,i5,i2)
coup4 = cplhhSdcSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MSd2(i2),Mhh2(i3),MSd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Su,hh,conj[Su],Su ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i2,i4)
coup3 = cplhhSucSu(i1,i5,i2)
coup4 = cplhhSucSu(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,Mhh2(i1),MSu2(i2),Mhh2(i3),MSu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,Su,conj[Hpm],conj[Su],Sd ----
Do i1=1,8
Do i2=1,6
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i2,i4)
coup3 = cplSdcHpmcSu(i5,i1,i2)
coup4 = cplHpmSucSd(i3,i4,i5)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MSu2(i2),MHpm2(i3),MSu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],conj[Hpm],Hpm,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2 = cplAhHpmcHpm(gE2,i4,i2)
coup3 = cplAhHpmcHpm(i5,i2,i1)
coup4 = cplAhHpmcHpm(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],conj[Hpm],Hpm,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2 = cplAhHpmcHpm(gE2,i4,i2)
coup3 = cplhhHpmcHpm(i5,i2,i1)
coup4 = cplhhHpmcHpm(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MHpm2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Sd],conj[Hpm],Sd,conj[Su] ----
Do i1=1,8
Do i2=1,6
Do i3=1,8
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i4,i2)
coup3 = cplSdcHpmcSu(i2,i1,i5)
coup4 = cplHpmSucSd(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MHpm2(i1),MSd2(i2),MHpm2(i3),MSd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],conj[Sd],Sd,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i4,i2)
coup3 = cplAhSdcSd(i5,i2,i1)
coup4 = cplAhSdcSd(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],conj[Sd],Sd,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2 = cplAhSdcSd(gE2,i4,i2)
coup3 = cplhhSdcSd(i5,i2,i1)
coup4 = cplhhSdcSd(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSd2(i2),MSd2(i3),MSd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Su],conj[Sd],Su,Hpm ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,8
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i4,i2)
coup3 = cplHpmSucSd(i5,i2,i1)
coup4 = cplSdcHpmcSu(i3,i5,i4)
prefactor=Real(2*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSd2(i1),MSu2(i2),MSd2(i3),MSu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],conj[Su],Su,Ah ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i4,i2)
coup3 = cplAhSucSu(i5,i2,i1)
coup4 = cplAhSucSu(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],conj[Su],Su,hh ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,6
Do i5=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2 = cplAhSucSu(gE2,i4,i2)
coup3 = cplhhSucSu(i5,i2,i1)
coup4 = cplhhSucSu(i5,i3,i4)
prefactor=Real(1*coup1*coup2*coup3*coup4*3,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSS(p2,MSu2(i1),MSu2(i2),MSu2(i3),MSu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- SCALAR AND VECTOR DIAGRAMS
! ----- Topology W_SSSV 

! ---- Sd,conj[Sd],Sd,VG ----
Do i1=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSV(p2,MSd2(i1),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
! ---- Su,conj[Su],Su,VG ----
Do i1=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i1)
coup2 = g3
coup3 = g3
prefactor=Real(1*coup1*coup2*coup3*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= -1._dp*WfSSSV(p2,MSu2(i1),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
! ----- Topology V_SSSSV 

! ----- Topology M_SSSSV 

! ---- Sd,conj[Sd],conj[Sd],Sd,VG ----
Do i1=1,6
Do i2=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i2,i1)
coup3 = g3
coup4 = g3
prefactor=Real(1*coup1*coup2*coup3*coup4*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSV(p2,MSd2(i1),MSd2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
! ---- Su,conj[Su],conj[Su],Su,VG ----
Do i1=1,6
Do i2=1,6
tempcouplingmatrix=0._dp
nonzerocoupling=.false.
Do gE1=1,6
  Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i2,i1)
coup3 = g3
coup4 = g3
prefactor=Real(1*coup1*coup2*coup3*coup4*4,dp)
if(abs(prefactor) .gt. epscouplings) then
tempcouplingmatrix(gE1,gE2)=tempcouplingmatrix(gE1,gE2)+prefactor
nonzerocoupling=.true.
end if
   End Do
End do
if(nonzerocoupling) then 
funcvalue= MfSSSSV(p2,MSu2(i1),MSu2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
! ----- FERMION AND SCALAR DIAGRAMS
! ----- Topology W_SSFF 

! ---- Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChaAhL(i3,i4,i2)
coup3R = cplcChaChaAhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChiAhL(i3,i4,i2)
coup3R = cplChiChiAhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdAhL(i3,i4,i2)
coup3R = cplcFdFdAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhAh(gE1,gE2,i1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuAhL(i3,i4,i2)
coup3R = cplcFuFuAhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),MAh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChaAhL(i4,i3,i1)
coup2R = cplcChaChaAhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplChiChiAhL(i3,i4,i1)
coup2R = cplChiChiAhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdAhL(i4,i3,i1)
coup2R = cplcFdFdAhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuAhL(i4,i3,i1)
coup2R = cplcFuFuAhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MAh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,5
if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcChaChahhL(i4,i3,i1)
coup2R = cplcChaChahhR(i4,i3,i1)
coup3L = cplcChaChahhL(i3,i4,i2)
coup3R = cplcChaChahhR(i3,i4,i2)
prefactor=Real(1._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MCha2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,8
if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplChiChihhL(i3,i4,i1)
coup2R = cplChiChihhR(i3,i4,i1)
coup3L = cplChiChihhL(i3,i4,i2)
coup3R = cplChiChihhR(i3,i4,i2)
prefactor=Real(1._dp/4._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MChi2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFdFdhhL(i4,i3,i1)
coup2R = cplcFdFdhhR(i4,i3,i1)
coup3L = cplcFdFdhhL(i3,i4,i2)
coup3R = cplcFdFdhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MFd2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,3
if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhhhh(gE1,gE2,i1,i2)
coup2L = cplcFuFuhhL(i4,i3,i1)
coup2R = cplcFuFuhhR(i4,i3,i1)
coup3L = cplcFuFuhhL(i3,i4,i2)
coup3R = cplcFuFuhhR(i3,i4,i2)
prefactor=Real(3._dp/2._dp*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,Mhh2(i1),Mhh2(i2),MFu2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Cha,Chi ----
Do i1=1,8
Do i2=1,8
Do i3=1,5
Do i4=1,8
if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplChiChacHpmL(i4,i3,i1)
coup2R = cplChiChacHpmR(i4,i3,i1)
coup3L = cplcChaChiHpmL(i3,i4,i2)
coup3R = cplcChaChiHpmR(i3,i4,i2)
prefactor=Real(1*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MHpm2(i1),MHpm2(i2),MCha2(i3),MChi2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Fd,bar[Fu] ----
Do i1=1,8
Do i2=1,8
Do i3=1,3
Do i4=1,3
if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhHpmcHpm(gE1,gE2,i1,i2)
coup2L = cplcFuFdcHpmL(i4,i3,i1)
coup2R = cplcFuFdcHpmR(i4,i3,i1)
coup3L = cplcFdFuHpmL(i3,i4,i2)
coup3R = cplcFdFuHpmR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MHpm2(i1),MHpm2(i2),MFd2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Cha,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,5
Do i4=1,3
if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChaFucSdL(i3,i4,i1)
coup2R = cplChaFucSdR(i3,i4,i1)
coup3L = cplcChacFuSdL(i3,i4,i2)
coup3R = cplcChacFuSdR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MCha2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Chi,Fd ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplChiFdcSdL(i3,i4,i1)
coup2R = cplChiFdcSdR(i3,i4,i1)
coup3L = cplcFdChiSdL(i4,i3,i2)
coup3R = cplcFdChiSdR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MChi2(i3),MFd2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Fd,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
if((MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSdcSd(gE1,gE2,i1,i2)
coup2L = cplGluFdcSdL(i3,i1)
coup2R = cplGluFdcSdR(i3,i1)
coup3L = cplcFdGluSdL(i3,i2)
coup3R = cplcFdGluSdR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSd2(i1),MSd2(i2),MFd2(i3),MGlu2,Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ---- Su,conj[Su],Chi,Fu ----
Do i1=1,6
Do i2=1,6
Do i3=1,8
Do i4=1,3
if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplChiFucSuL(i3,i4,i1)
coup2R = cplChiFucSuR(i3,i4,i1)
coup3L = cplcFuChiSuL(i4,i3,i2)
coup3R = cplcFuChiSuR(i4,i3,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MChi2(i3),MFu2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Fd,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
Do i4=1,5
if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplcChaFdcSuL(i4,i3,i1)
coup2R = cplcChaFdcSuR(i4,i3,i1)
coup3L = cplcFdChaSuL(i3,i4,i2)
coup3R = cplcFdChaSuR(i3,i4,i2)
prefactor=Real(3*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MFd2(i3),MCha2(i4),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Su,conj[Su],Fu,Glu ----
Do i1=1,6
Do i2=1,6
Do i3=1,3
if((MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3L+coup1*coup2R*coup3R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFbFb(p2,MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhSucSu(gE1,gE2,i1,i2)
coup2L = cplGluFucSuL(i3,i1)
coup2R = cplGluFucSuR(i3,i1)
coup3L = cplcFuGluSuL(i3,i2)
coup3R = cplcFuGluSuR(i3,i2)
prefactor=Real(4*(coup1*coup2L*coup3R+coup1*coup2R*coup3L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= -1._dp*WfSSFF(p2,MSu2(i1),MSu2(i2),MFu2(i3),MGlu2,Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
! ----- Topology M_FFFFS 

! ---- Cha,Chi,bar[Cha],Chi,Hpm ----
Do i1=1,5
Do i2=1,8
Do i3=1,5
Do i4=1,8
Do i5=1,8
if((MCha(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MChi(i2)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MChi(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcChaChiHpmL(i1,i2,i5)
coup3R = cplcChaChiHpmR(i1,i2,i5)
coup4L = cplChiChacHpmL(i4,i3,i5)
coup4R = cplChiChacHpmR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MChi2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,Fu,bar[Cha],bar[Fu],Sd ----
Do i1=1,5
Do i2=1,3
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MFu(i2)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MFu(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i1,i2,i5)
coup3R = cplcChacFuSdR(i1,i2,i5)
coup4L = cplChaFucSdL(i3,i4,i5)
coup4R = cplChaFucSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MFu2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],bar[Cha],Cha,Ah ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChaAhL(i1,i2,i5)
coup3R = cplcChaChaAhR(i1,i2,i5)
coup4L = cplcChaChaAhL(i4,i3,i5)
coup4R = cplcChaChaAhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],bar[Cha],Cha,hh ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcChaChahhL(i1,i2,i5)
coup3R = cplcChaChahhR(i1,i2,i5)
coup4L = cplcChaChahhL(i4,i3,i5)
coup4R = cplcChaChahhR(i4,i3,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Fd],bar[Cha],Fd,conj[Su] ----
Do i1=1,5
Do i2=1,3
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MFd(i2)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MFd(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i3,i1,gE1)
coup1R = cplcChaChaAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i1,i2,i5)
coup3R = cplcChaFdcSuR(i1,i2,i5)
coup4L = cplcFdChaSuL(i4,i3,i5)
coup4R = cplcFdChaSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MCha2(i1),MFd2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Cha,Chi,bar[Cha],Hpm ----
Do i1=1,8
Do i2=1,5
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MChi(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MCha(i2)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MCha(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChiHpmL(i2,i1,i5)
coup3R = cplcChaChiHpmR(i2,i1,i5)
coup4L = cplChiChacHpmL(i3,i4,i5)
coup4R = cplChiChacHpmR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MCha2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i1,i2,i5)
coup3R = cplChiChiAhR(i1,i2,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i1,i2,i5)
coup3R = cplChiChihhR(i1,i2,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1._dp/2._dp*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Fd,Chi,bar[Fd],Sd ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MFd(i2)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MFd(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdChiSdL(i2,i1,i5)
coup3R = cplcFdChiSdR(i2,i1,i5)
coup4L = cplChiFdcSdL(i3,i4,i5)
coup4R = cplChiFdcSdR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MFd2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Fu,Chi,bar[Fu],Su ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MFu(i2)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MFu(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i3,gE1)
coup1R = cplChiChiAhR(i1,i3,gE1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuChiSuL(i2,i1,i5)
coup3R = cplcFuChiSuR(i2,i1,i5)
coup4L = cplChiFucSuL(i3,i4,i5)
coup4R = cplChiFucSuR(i3,i4,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MChi2(i1),MFu2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,Chi,bar[Fd],Chi,Sd ----
Do i1=1,3
Do i2=1,8
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MChi(i2)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MChi(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFdChiSdL(i1,i2,i5)
coup3R = cplcFdChiSdR(i1,i2,i5)
coup4L = cplChiFdcSdL(i4,i3,i5)
coup4R = cplChiFdcSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MChi2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Cha],bar[Fd],Cha,Su ----
Do i1=1,3
Do i2=1,5
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MCha(i2)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MCha(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplcFdChaSuL(i1,i2,i5)
coup3R = cplcFdChaSuR(i1,i2,i5)
coup4L = cplcChaFdcSuL(i4,i3,i5)
coup4R = cplcChaFdcSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MCha2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],bar[Fd],Fd,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdAhL(i1,i2,i5)
coup3R = cplcFdFdAhR(i1,i2,i5)
coup4L = cplcFdFdAhL(i4,i3,i5)
coup4R = cplcFdFdAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],bar[Fd],Fd,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFdFdhhL(i1,i2,i5)
coup3R = cplcFdFdhhR(i1,i2,i5)
coup4L = cplcFdFdhhL(i4,i3,i5)
coup4R = cplcFdFdhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fu],bar[Fd],Fu,Hpm ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFd(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFu(i2)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i3,i1,gE1)
coup1R = cplcFdFdAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFdFuHpmL(i1,i2,i5)
coup3R = cplcFdFuHpmR(i1,i2,i5)
coup4L = cplcFuFdcHpmL(i4,i3,i5)
coup4R = cplcFuFdcHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFd2(i1),MFu2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,Cha,bar[Fu],bar[Cha],Sd ----
Do i1=1,3
Do i2=1,5
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MCha(i2)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MCha(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MCha(i2)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChacFuSdL(i2,i1,i5)
coup3R = cplcChacFuSdR(i2,i1,i5)
coup4L = cplChaFucSdL(i4,i3,i5)
coup4R = cplChaFucSdR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MCha2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,Chi,bar[Fu],Chi,Su ----
Do i1=1,3
Do i2=1,8
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MChi(i2)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MChi(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MChi(i2)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplcFuChiSuL(i1,i2,i5)
coup3R = cplcFuChiSuR(i1,i2,i5)
coup4L = cplChiFucSuL(i4,i3,i5)
coup4R = cplChiFucSuR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MChi2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fd],bar[Fu],Fd,conj[Hpm] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFu(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFd(i2)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i1,i2,i5)
coup3R = cplcFuFdcHpmR(i1,i2,i5)
coup4L = cplcFdFuHpmL(i4,i3,i5)
coup4R = cplcFdFuHpmR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFd2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],bar[Fu],Fu,Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuAhL(i1,i2,i5)
coup3R = cplcFuFuAhR(i1,i2,i5)
coup4L = cplcFuFuAhL(i4,i3,i5)
coup4R = cplcFuFuAhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],bar[Fu],Fu,hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFbFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i3,i1,gE1)
coup1R = cplcFuFuAhR(i3,i1,gE1)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplcFuFuhhL(i1,i2,i5)
coup3R = cplcFuFuhhR(i1,i2,i5)
coup4L = cplcFuFuhhL(i4,i3,i5)
coup4R = cplcFuFuhhR(i4,i3,i5)
prefactor=Real(3*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- Topology M_SFSFF 

! ---- Ah,Cha,Ah,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Chi,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fd,Ah,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fu,Ah,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Cha,hh,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChaAhL(i2,i5,i1)
coup3R = cplcChaChaAhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Chi,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChiAhL(i2,i5,i1)
coup3R = cplChiChiAhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fd,hh,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdAhL(i2,i5,i1)
coup3R = cplcFdFdAhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Ah,Fu,hh,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuAhL(i2,i5,i1)
coup3R = cplcFuFuAhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MAh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Cha,Ah,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChaAhL(i5,i4,i3)
coup4R = cplcChaChaAhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MCha2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Chi,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MChi2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fd,Ah,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdAhL(i5,i4,i3)
coup4R = cplcFdFdAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFd2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fu,Ah,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i3,i1)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuAhL(i5,i4,i3)
coup4R = cplcFuFuAhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFu2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Cha,hh,bar[Cha],Cha ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i2)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaChahhL(i2,i5,i1)
coup3R = cplcChaChahhR(i2,i5,i1)
coup4L = cplcChaChahhL(i5,i4,i3)
coup4R = cplcChaChahhR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MCha2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Chi,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i2)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChihhL(i2,i5,i1)
coup3R = cplChiChihhR(i2,i5,i1)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MChi2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fd,hh,bar[Fd],Fd ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i2)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFdFdAhL(i4,i2,gE2)
coup2R = cplcFdFdAhR(i4,i2,gE2)
coup3L = cplcFdFdhhL(i2,i5,i1)
coup3R = cplcFdFdhhR(i2,i5,i1)
coup4L = cplcFdFdhhL(i5,i4,i3)
coup4R = cplcFdFdhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFd2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- hh,Fu,hh,bar[Fu],Fu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i2)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFuhhL(i2,i5,i1)
coup3R = cplcFuFuhhR(i2,i5,i1)
coup4L = cplcFuFuhhL(i5,i4,i3)
coup4R = cplcFuFuhhR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,Mhh2(i1),MFu2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,Chi,conj[Hpm],Chi,Cha ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,5
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i2)*MChi(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i2,i5,i1)
coup3R = cplChiChacHpmR(i2,i5,i1)
coup4L = cplcChaChiHpmL(i5,i4,i3)
coup4R = cplcChaChiHpmR(i5,i4,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MChi2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,Fu,conj[Hpm],bar[Fu],Fd ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i2)*MFu(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFuFuAhL(i4,i2,gE2)
coup2R = cplcFuFuAhR(i4,i2,gE2)
coup3L = cplcFuFdcHpmL(i2,i5,i1)
coup3R = cplcFuFdcHpmR(i2,i5,i1)
coup4L = cplcFdFuHpmL(i5,i4,i3)
coup4R = cplcFdFuHpmR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MFu2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,bar[Cha],conj[Hpm],Cha,Chi ----
Do i1=1,8
Do i2=1,5
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MCha(i2)*MCha(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(4*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChiChacHpmL(i5,i2,i1)
coup3R = cplChiChacHpmR(i5,i2,i1)
coup4L = cplcChaChiHpmL(i4,i5,i3)
coup4R = cplcChaChiHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MCha2(i2),MHpm2(i3),MCha2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Hpm,bar[Fd],conj[Hpm],Fd,bar[Fu] ----
Do i1=1,8
Do i2=1,3
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFd(i2)*MFd(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcFuFdcHpmL(i5,i2,i1)
coup3R = cplcFuFdcHpmR(i5,i2,i1)
coup4L = cplcFdFuHpmL(i4,i5,i3)
coup4R = cplcFdFuHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MHpm2(i1),MFd2(i2),MHpm2(i3),MFd2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,Chi,conj[Sd],Chi,Fd ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i2)*MChi(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i2,i5,i1)
coup3R = cplChiFdcSdR(i2,i5,i1)
coup4L = cplcFdChiSdL(i5,i4,i3)
coup4R = cplcFdChiSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MChi2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Cha],conj[Sd],Cha,Fu ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i2)*MCha(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcChaChaAhL(i2,i4,gE2)
coup2R = cplcChaChaAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i2,i5,i1)
coup3R = cplChaFucSdR(i2,i5,i1)
coup4L = cplcChacFuSdL(i4,i5,i3)
coup4R = cplcChacFuSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MCha2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Fd],conj[Sd],Fd,Chi ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,8
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MFd(i2)*MFd(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplChiFdcSdL(i5,i2,i1)
coup3R = cplChiFdcSdR(i5,i2,i1)
coup4L = cplcFdChiSdL(i4,i5,i3)
coup4R = cplcFdChiSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Sd,bar[Fd],conj[Sd],Fd,Glu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MFd(i2)*MFd(i4)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(16*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplGluFdcSdL(i2,i1)
coup3R = cplGluFdcSdR(i2,i1)
coup4L = cplcFdGluSdL(i4,i3)
coup4R = cplcFdGluSdR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFd2(i2),MSd2(i3),MFd2(i4),MGlu2,Qscale)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
! ---- Sd,bar[Fu],conj[Sd],Fu,Cha ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,5
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MFu(i2)*MFu(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChaFucSdL(i5,i2,i1)
coup3R = cplChaFucSdR(i5,i2,i1)
coup4L = cplcChacFuSdL(i5,i4,i3)
coup4R = cplcChacFuSdR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSd2(i1),MFu2(i2),MSd2(i3),MFu2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,Cha,conj[Su],bar[Cha],Fd ----
Do i1=1,6
Do i2=1,5
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i2).gt. epsfmass).and. (MCha(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i2)*MCha(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcChaChaAhL(i4,i2,gE2)
coup2R = cplcChaChaAhR(i4,i2,gE2)
coup3L = cplcChaFdcSuL(i2,i5,i1)
coup3R = cplcChaFdcSuR(i2,i5,i1)
coup4L = cplcFdChaSuL(i5,i4,i3)
coup4R = cplcFdChaSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MCha2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,Chi,conj[Su],Chi,Fu ----
Do i1=1,6
Do i2=1,8
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i2).gt. epsfmass).and. (MChi(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i2)*MChi(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplChiChiAhL(i2,i4,gE2)
coup2R = cplChiChiAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i2,i5,i1)
coup3R = cplChiFucSuR(i2,i5,i1)
coup4L = cplcFuChiSuL(i5,i4,i3)
coup4R = cplcFuChiSuR(i5,i4,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MChi2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fd],conj[Su],Fd,bar[Cha] ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,5
if((MFd(i2).gt. epsfmass).and. (MFd(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MFd(i2)*MFd(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFdFdAhL(i2,i4,gE2)
coup2R = cplcFdFdAhR(i2,i4,gE2)
coup3L = cplcChaFdcSuL(i5,i2,i1)
coup3R = cplcChaFdcSuR(i5,i2,i1)
coup4L = cplcFdChaSuL(i4,i5,i3)
coup4R = cplcFdChaSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFd2(i2),MSu2(i3),MFd2(i4),MCha2(i5),Qscale)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fu],conj[Su],Fu,Chi ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
Do i5=1,8
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MFu(i2)*MFu(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(12*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplChiFucSuL(i5,i2,i1)
coup3R = cplChiFucSuR(i5,i2,i1)
coup4L = cplcFuChiSuL(i4,i5,i3)
coup4R = cplcFuChiSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MChi2(i5),Qscale)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
End do
! ---- Su,bar[Fu],conj[Su],Fu,Glu ----
Do i1=1,6
Do i2=1,3
Do i3=1,6
Do i4=1,3
if((MFu(i2).gt. epsfmass).and. (MFu(i4).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3L*coup4L+coup1*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFbSFbFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MFu(i2)*MFu(i4)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(16*(coup1*coup2L*coup3R*coup4L+coup1*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFbF(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i3)
coup2L = cplcFuFuAhL(i2,i4,gE2)
coup2R = cplcFuFuAhR(i2,i4,gE2)
coup3L = cplGluFucSuL(i2,i1)
coup3R = cplGluFucSuR(i2,i1)
coup4L = cplcFuGluSuL(i4,i3)
coup4R = cplcFuGluSuR(i4,i3)
prefactor=Real(8*(coup1*coup2L*coup3R*coup4R+coup1*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= MfSFSFFb(p2,MSu2(i1),MFu2(i2),MSu2(i3),MFu2(i4),MGlu2,Qscale)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
End do
End do
! ----- Topology V_SSSFF 

! ---- Ah,Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhAh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhAh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Ah,hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i1,i2)
coup2 = cplAhAhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MAh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChaAhL(i4,i5,i3)
coup4R = cplcChaChaAhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChiAhL(i4,i5,i3)
coup4R = cplChiChiAhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdAhL(i4,i5,i3)
coup4R = cplcFdFdAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,Ah,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhAhhh(gE2,i3,i1)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuAhL(i4,i5,i3)
coup4R = cplcFuFuAhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),MAh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcChaChaAhL(i5,i4,i2)
coup3R = cplcChaChaAhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplChiChiAhL(i4,i5,i2)
coup3R = cplChiChiAhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFdFdAhL(i5,i4,i2)
coup3R = cplcFdFdAhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,Ah,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhAhhh(gE1,i2,i1)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFuFuAhL(i5,i4,i2)
coup3R = cplcFuFuAhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),MAh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Cha,bar[Cha] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,5
if((MCha(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)*MCha(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcChaChahhL(i5,i4,i2)
coup3R = cplcChaChahhR(i5,i4,i2)
coup4L = cplcChaChahhL(i4,i5,i3)
coup4R = cplcChaChahhR(i4,i5,i3)
prefactor=Real(1*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MCha2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Chi,Chi ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,8
if((MChi(i4).gt. epsfmass).and. (MChi(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)*MChi(i4)*MChi(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplChiChihhL(i4,i5,i2)
coup3R = cplChiChihhR(i4,i5,i2)
coup4L = cplChiChihhL(i4,i5,i3)
coup4R = cplChiChihhR(i4,i5,i3)
prefactor=Real(1._dp/2._dp*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MChi2(i4),MChi2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Fd,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFd(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)*MFd(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFdFdhhL(i5,i4,i2)
coup3R = cplcFdFdhhR(i5,i4,i2)
coup4L = cplcFdFdhhL(i4,i5,i3)
coup4R = cplcFdFdhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFd2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- hh,hh,hh,Fu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)*MFu(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhhhhh(gE1,i1,i2)
coup2 = cplAhhhhh(gE2,i1,i3)
coup3L = cplcFuFuhhL(i5,i4,i2)
coup3R = cplcFuFuhhR(i5,i4,i2)
coup4L = cplcFuFuhhL(i4,i5,i3)
coup4R = cplcFuFuhhR(i4,i5,i3)
prefactor=Real(3*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,Mhh2(i1),Mhh2(i2),Mhh2(i3),MFu2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Chi,bar[Cha] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,5
if((MChi(i4).gt. epsfmass).and. (MCha(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3L = cplcChaChiHpmL(i5,i4,i2)
coup3R = cplcChaChiHpmR(i5,i4,i2)
coup4L = cplChiChacHpmL(i4,i5,i3)
coup4R = cplChiChacHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)*MChi(i4)*MCha(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3L = cplcChaChiHpmL(i5,i4,i2)
coup3R = cplcChaChiHpmR(i5,i4,i2)
coup4L = cplChiChacHpmL(i4,i5,i3)
coup4R = cplChiChacHpmR(i4,i5,i3)
prefactor=Real(2*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MChi2(i4),MCha2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Hpm,conj[Hpm],Hpm,Fu,bar[Fd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,3
if((MFu(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3L = cplcFdFuHpmL(i5,i4,i2)
coup3R = cplcFdFuHpmR(i5,i4,i2)
coup4L = cplcFuFdcHpmL(i4,i5,i3)
coup4R = cplcFuFdcHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)*MFu(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhHpmcHpm(gE1,i1,i2)
coup2 = cplAhHpmcHpm(gE2,i3,i1)
coup3L = cplcFdFuHpmL(i5,i4,i2)
coup3R = cplcFdFuHpmR(i5,i4,i2)
coup4L = cplcFuFdcHpmL(i4,i5,i3)
coup4R = cplcFuFdcHpmR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MHpm2(i1),MHpm2(i2),MHpm2(i3),MFu2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Chi,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcFdChiSdL(i5,i4,i2)
coup3R = cplcFdChiSdR(i5,i4,i2)
coup4L = cplChiFdcSdL(i4,i5,i3)
coup4R = cplChiFdcSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)*MChi(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcFdChiSdL(i5,i4,i2)
coup3R = cplcFdChiSdR(i5,i4,i2)
coup4L = cplChiFdcSdL(i4,i5,i3)
coup4R = cplChiFdcSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MChi2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,Glu,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i5=1,3
if((MGlu.gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcFdGluSdL(i5,i2)
coup3R = cplcFdGluSdR(i5,i2)
coup4L = cplGluFdcSdL(i5,i3)
coup4R = cplGluFdcSdR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MGlu2,MFd2(i5),Qscale)*MGlu*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcFdGluSdL(i5,i2)
coup3R = cplcFdGluSdR(i5,i2)
coup4L = cplGluFdcSdL(i5,i3)
coup4R = cplGluFdcSdR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MGlu2,MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Sd,conj[Sd],Sd,bar[Cha],bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcChacFuSdL(i4,i5,i2)
coup3R = cplcChacFuSdR(i4,i5,i2)
coup4L = cplChaFucSdL(i4,i5,i3)
coup4R = cplChaFucSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSd2(i1),MSd2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)*MCha(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSdcSd(gE1,i1,i2)
coup2 = cplAhSdcSd(gE2,i3,i1)
coup3L = cplcChacFuSdL(i4,i5,i2)
coup3R = cplcChacFuSdR(i4,i5,i2)
coup4L = cplChaFucSdL(i4,i5,i3)
coup4R = cplChaFucSdR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSd2(i1),MSd2(i2),MSd2(i3),MCha2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Cha,bar[Fd] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,5
Do i5=1,3
if((MCha(i4).gt. epsfmass).and. (MFd(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFdChaSuL(i5,i4,i2)
coup3R = cplcFdChaSuR(i5,i4,i2)
coup4L = cplcChaFdcSuL(i4,i5,i3)
coup4R = cplcChaFdcSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)*MCha(i4)*MFd(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFdChaSuL(i5,i4,i2)
coup3R = cplcFdChaSuR(i5,i4,i2)
coup4L = cplcChaFdcSuL(i4,i5,i3)
coup4R = cplcChaFdcSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MCha2(i4),MFd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Chi,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i4=1,8
Do i5=1,3
if((MChi(i4).gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFuChiSuL(i5,i4,i2)
coup3R = cplcFuChiSuR(i5,i4,i2)
coup4L = cplChiFucSuL(i4,i5,i3)
coup4R = cplChiFucSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)*MChi(i4)*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFuChiSuL(i5,i4,i2)
coup3R = cplcFuChiSuR(i5,i4,i2)
coup4L = cplChiFucSuL(i4,i5,i3)
coup4R = cplChiFucSuR(i4,i5,i3)
prefactor=Real(6*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MChi2(i4),MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Su,conj[Su],Su,Glu,bar[Fu] ----
Do i1=1,6
Do i2=1,6
Do i3=1,6
Do i5=1,3
if((MGlu.gt. epsfmass).and. (MFu(i5).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFuGluSuL(i5,i2)
coup3R = cplcFuGluSuR(i5,i2)
coup4L = cplGluFucSuL(i5,i3)
coup4R = cplGluFucSuR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4L+coup1*coup2*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFbFb(p2,MSu2(i1),MSu2(i2),MSu2(i3),MGlu2,MFu2(i5),Qscale)*MGlu*MFu(i5)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1 = cplAhSucSu(gE1,i1,i2)
coup2 = cplAhSucSu(gE2,i3,i1)
coup3L = cplcFuGluSuL(i5,i2)
coup3R = cplcFuGluSuR(i5,i2)
coup4L = cplGluFucSuL(i5,i3)
coup4R = cplGluFucSuR(i5,i3)
prefactor=Real(8*(coup1*coup2*coup3L*coup4R+coup1*coup2*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfSSSFF(p2,MSu2(i1),MSu2(i2),MSu2(i3),MGlu2,MFu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ----- Topology V_FFFFS 

! ---- Cha,bar[Cha],Cha,bar[Cha],Ah ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChaAhL(i4,i2,i5)
coup3R = cplcChaChaAhR(i4,i2,i5)
coup4L = cplcChaChaAhL(i3,i4,i5)
coup4R = cplcChaChaAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,Chi,conj[Hpm] ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,8
Do i5=1,8
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)*MCha(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i4,i2,i5)
coup3R = cplChiChacHpmR(i4,i2,i5)
coup4L = cplcChaChiHpmL(i3,i4,i5)
coup4R = cplcChaChiHpmR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MChi2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,Fu,conj[Sd] ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)*MCha(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i2,i4,i5)
coup3R = cplChaFucSdR(i2,i4,i5)
coup4L = cplcChacFuSdL(i3,i4,i5)
coup4R = cplcChacFuSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFu2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,bar[Cha],hh ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,5
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)*MCha(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcChaChahhL(i4,i2,i5)
coup3R = cplcChaChahhR(i4,i2,i5)
coup4L = cplcChaChahhL(i3,i4,i5)
coup4R = cplcChaChahhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MCha2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Cha,bar[Cha],Cha,bar[Fd],Su ----
Do i1=1,5
Do i2=1,5
Do i3=1,5
Do i4=1,3
Do i5=1,6
if((MCha(i1).gt. epsfmass).and. (MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MCha(i2)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i2).gt. epsfmass).and. (MCha(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i2)*MCha(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MCha(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)*MCha(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcChaChaAhL(i2,i1,gE1)
coup1R = cplcChaChaAhR(i2,i1,gE1)
coup2L = cplcChaChaAhL(i1,i3,gE2)
coup2R = cplcChaChaAhR(i1,i3,gE2)
coup3L = cplcFdChaSuL(i4,i2,i5)
coup3R = cplcFdChaSuR(i4,i2,i5)
coup4L = cplcChaFdcSuL(i3,i4,i5)
coup4R = cplcChaFdcSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MCha2(i1),MCha2(i2),MCha2(i3),MFd2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,Ah ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChiAhL(i2,i4,i5)
coup3R = cplChiChiAhR(i2,i4,i5)
coup4L = cplChiChiAhL(i3,i4,i5)
coup4R = cplChiChiAhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Cha,conj[Hpm] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,5
Do i5=1,8
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(4*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(4*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)*MChi(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChacHpmL(i2,i4,i5)
coup3R = cplChiChacHpmR(i2,i4,i5)
coup4L = cplcChaChiHpmL(i4,i3,i5)
coup4R = cplcChaChiHpmR(i4,i3,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MCha2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Chi,hh ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,8
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(2*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)*MChi(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiChihhL(i2,i4,i5)
coup3R = cplChiChihhR(i2,i4,i5)
coup4L = cplChiChihhL(i3,i4,i5)
coup4R = cplChiChihhR(i3,i4,i5)
prefactor=Real(1*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MChi2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Fd,conj[Sd] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)*MChi(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i2,i4,i5)
coup3R = cplChiFdcSdR(i2,i4,i5)
coup4L = cplcFdChiSdL(i4,i3,i5)
coup4R = cplcFdChiSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFd2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Chi,Chi,Chi,Fu,conj[Su] ----
Do i1=1,8
Do i2=1,8
Do i3=1,8
Do i4=1,3
Do i5=1,6
if((MChi(i1).gt. epsfmass).and. (MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MChi(i2)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i2).gt. epsfmass).and. (MChi(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i2)*MChi(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MChi(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)*MChi(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplChiChiAhL(i1,i2,gE1)
coup1R = cplChiChiAhR(i1,i2,gE1)
coup2L = cplChiChiAhL(i1,i3,gE2)
coup2R = cplChiChiAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i2,i4,i5)
coup3R = cplChiFucSuR(i2,i4,i5)
coup4L = cplcFuChiSuL(i4,i3,i5)
coup4R = cplcFuChiSuR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MChi2(i1),MChi2(i2),MChi2(i3),MFu2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fd],Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdAhL(i4,i2,i5)
coup3R = cplcFdFdAhR(i4,i2,i5)
coup4L = cplcFdFdAhL(i3,i4,i5)
coup4R = cplcFdFdAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,Chi,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)*MFd(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplChiFdcSdL(i4,i2,i5)
coup3R = cplChiFdcSdR(i4,i2,i5)
coup4L = cplcFdChiSdL(i3,i4,i5)
coup4R = cplcFdChiSdR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MChi2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,Glu,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(16*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i1)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(16*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)*MFd(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplGluFdcSdL(i2,i5)
coup3R = cplGluFdcSdR(i2,i5)
coup4L = cplcFdGluSdL(i3,i5)
coup4R = cplcFdGluSdR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MGlu2,MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fd],hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)*MFd(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFdFdhhL(i4,i2,i5)
coup3R = cplcFdFdhhR(i4,i2,i5)
coup4L = cplcFdFdhhL(i3,i4,i5)
coup4R = cplcFdFdhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFd2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Cha],conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)*MFd(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcChaFdcSuL(i4,i2,i5)
coup3R = cplcChaFdcSuR(i4,i2,i5)
coup4L = cplcFdChaSuL(i3,i4,i5)
coup4R = cplcFdChaSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MCha2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fd,bar[Fd],Fd,bar[Fu],conj[Hpm] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFd(i2)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i2).gt. epsfmass).and. (MFd(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i2)*MFd(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFd(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)*MFd(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i3,gE2)
coup2R = cplcFdFdAhR(i1,i3,gE2)
coup3L = cplcFuFdcHpmL(i4,i2,i5)
coup3R = cplcFuFdcHpmR(i4,i2,i5)
coup4L = cplcFdFuHpmL(i3,i4,i5)
coup4R = cplcFdFuHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFd2(i1),MFd2(i2),MFd2(i3),MFu2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fu],Ah ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuAhL(i4,i2,i5)
coup3R = cplcFuFuAhR(i4,i2,i5)
coup4L = cplcFuFuAhL(i3,i4,i5)
coup4R = cplcFuFuAhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),MAh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Cha,conj[Sd] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,5
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i1)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MCha(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)*MFu(i3)*MCha(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChaFucSdL(i4,i2,i5)
coup3R = cplChaFucSdR(i4,i2,i5)
coup4L = cplcChacFuSdL(i4,i3,i5)
coup4R = cplcChacFuSdR(i4,i3,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MCha2(i4),MSd2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Chi,conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,8
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i1)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MChi(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)*MFu(i3)*MChi(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplChiFucSuL(i4,i2,i5)
coup3R = cplChiFucSuR(i4,i2,i5)
coup4L = cplcFuChiSuL(i3,i4,i5)
coup4R = cplcFuChiSuR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MChi2(i4),MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,Glu,conj[Su] ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(16*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i1)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MGlu.gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(16*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)*MFu(i3)*MGlu
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplGluFucSuL(i2,i5)
coup3R = cplGluFucSuR(i2,i5)
coup4L = cplcFuGluSuL(i3,i5)
coup4R = cplcFuGluSuR(i3,i5)
prefactor=Real(8*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MGlu2,MSu2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fu],hh ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,6
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i1)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFu(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)*MFu(i3)*MFu(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFuFuhhL(i4,i2,i5)
coup3R = cplcFuFuhhR(i4,i2,i5)
coup4L = cplcFuFuhhL(i3,i4,i5)
coup4R = cplcFuFuhhR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFu2(i4),Mhh2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ---- Fu,bar[Fu],Fu,bar[Fd],Hpm ----
Do i1=1,3
Do i2=1,3
Do i3=1,3
Do i4=1,3
Do i5=1,8
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3L*coup4L+coup1R*coup2R*coup3R*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFbFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFu(i2)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2L*coup3R*coup4L+coup1R*coup2R*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i1).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2L*coup3R*coup4R+coup1R*coup2R*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFbFFFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i1)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i2).gt. epsfmass).and. (MFu(i3).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3L*coup4R+coup1R*coup2L*coup3R*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFbFbFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i2)*MFu(i3)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

if((MFu(i3).gt. epsfmass).and. (MFd(i4).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(12*(coup1L*coup2R*coup3R*coup4R+coup1R*coup2L*coup3L*coup4L),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFbFbS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)*MFu(i3)*MFd(i4)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i3,gE2)
coup2R = cplcFuFuAhR(i1,i3,gE2)
coup3L = cplcFdFuHpmL(i4,i2,i5)
coup3R = cplcFdFuHpmR(i4,i2,i5)
coup4L = cplcFuFdcHpmL(i3,i4,i5)
coup4R = cplcFuFdcHpmR(i3,i4,i5)
prefactor=Real(6*(coup1L*coup2R*coup3R*coup4L+coup1R*coup2L*coup3L*coup4R),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= VfFFFFS(p2,MFu2(i1),MFu2(i2),MFu2(i3),MFd2(i4),MHpm2(i5),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
End do
End do
End do
End do
End do
! ----- FERMION AND VECTOR DIAGRAMS
! ----- Topology G_FFFFV 

! ---- Fd,bar[Fd],Fd,VG,bar[Fd] ----
Do i1=1,3
Do i2=1,3
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i2,gE2)
coup2R = cplcFdFdAhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2R*coup3*coup4+coup1R*coup2L*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFFV(p2,MFd2(i1),MFd2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
if((MFd(i1).gt. epsfmass).and. (MFd(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFdFdAhL(i2,i1,gE1)
coup1R = cplcFdFdAhR(i2,i1,gE1)
coup2L = cplcFdFdAhL(i1,i2,gE2)
coup2R = cplcFdFdAhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2L*coup3*coup4+coup1R*coup2R*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFbFbV(p2,MFd2(i1),MFd2(i2),Qscale)*MFd(i1)*MFd(i2)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
! ---- Fu,bar[Fu],Fu,VG,bar[Fu] ----
Do i1=1,3
Do i2=1,3
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i2,gE2)
coup2R = cplcFuFuAhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2R*coup3*coup4+coup1R*coup2L*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFFV(p2,MFu2(i1),MFu2(i2),Qscale)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
if((MFu(i1).gt. epsfmass).and. (MFu(i2).gt. epsfmass)) then 
nonzerocoupling=.false.
  Do gE1=1,6
   Do gE2=1,6
coup1L = cplcFuFuAhL(i2,i1,gE1)
coup1R = cplcFuFuAhR(i2,i1,gE1)
coup2L = cplcFuFuAhL(i1,i2,gE2)
coup2R = cplcFuFuAhR(i1,i2,gE2)
coup3=g3
coup4=g3
prefactor=Real(4*(coup1L*coup2L*coup3*coup4+coup1R*coup2R*coup3*coup4),dp)
if(abs(prefactor) .gt. epscouplings) then
 tempcouplingmatrix(gE1,gE2)=prefactor
 nonzerocoupling=.true.
 else
 tempcouplingmatrix(gE1,gE2)= 0._dp
 end if
   End Do
  End do
if(nonzerocoupling) then 
 funcvalue= GfFbFbV(p2,MFu2(i1),MFu2(i2),Qscale)*MFu(i1)*MFu(i2)
 tempcont=tempcont+tempcouplingmatrix*funcvalue
end if
end if

End do
End do
! ----- TIDY UP AND SYMMETRISE -----
do gE1=1,6
Pi2P(gE1,gE1)=Pi2P(gE1,gE1)+tempcont(gE1,gE1)*oo16Pi2*oo16Pi2
do gE2=1,gE1-1
Pi2P(gE1,gE2)=Pi2P(gE1,gE2)+0.5_dp*(tempcont(gE1,gE2)+tempcont(gE2,gE1))*oo16Pi2*oo16Pi2
Pi2P(gE2,gE1)=Pi2P(gE1,gE2)
End do
End do
Pi2P = Matmul(Pi2P,ZA)
Pi2P = Matmul(Transpose(ZA),Pi2P)
End Subroutine CalculatePi2S
End Module Pole2L_munuSSM 
 
